﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

//This file handles all of the control activation code (i.e. Buttons, setVariables, ListBoxes, etc.)
//There is a single function for all controls of the same type


//LIST BOXES------------------------------------------------------------
Function ntListBoxProc(lba) : ListBoxControl
	STRUCT WMListboxAction &lba

	Variable row = lba.row
	Variable col = lba.col
	WAVE/T/Z listWave = lba.listWave
	WAVE/Z selWave = lba.selWave
	Variable errorCode = 0
	
	DFREF NPD = $DSF
	DFREF NPC = $CW
	
	NVAR dragging = NPC:dragging
	SVAR listFocus = NPC:listFocus
	
	Variable hookResult = 0
	
	switch( lba.eventCode )
		case -1: // control being killed
			break
		case 1: // mouse down
			//set a potential drag variable
			If(!cmpstr(lba.ctrlName,"waveListBox"))
				dragging = 1
				//freeze selection

			EndIf
			
			break
		case 2: // mouse up
			//display the full path to the wave in a text box
			//reset the drag and drop variable on a mouse up
			dragging = 0
			
//			If(row > DimSize(selWave,0) - 1 || row == -1)
//				break
//			EndIf
//			
//			strswitch(lba.ctrlName)
//				case "MatchListBox":
//				case "DataSetWavesListBox":
//					DrawAction/W=NTP getGroup=fullPathText,delete
//					SetDrawEnv/W=NTP fname=$LIGHT,fstyle=2,fsize=10,xcoord=abs,ycoord=abs, textxjust= 0,gname=fullPathText,gstart
//					DrawText/W=NTP 14,464,listWave[row][0][1]
//					SetDrawEnv/W=NTP gstop
//					break
//			endswitch
					
			//change focus for the list box selection
			strswitch(lba.ctrlName)
				case "matchListBox": //wave matches
					
					GetWindow NTP#Nav#Viewer hide
					If(V_Value == 1)
						DisplayWaveNote(listWave,selWave)
						AppendToViewer(listWave,selWave)
					Else
						AppendToViewer(listWave,selWave)
					EndIf
					
					//out of range selection
					If(row > DimSize(listWave,0) - 1)
						//change the list box focus still
						changeFocus("WaveMatch",1)
						
						//Delete full path wave text
						DrawAction/W=NTP getGroup=fullPathText,delete
						return 0
					EndIf
									
					//change the list box focus
					If(!cmpstr(listFocus,"DataSet"))
						changeFocus("WaveMatch",1)
					EndIf
							
					break
				case "dataSetWavesListBox": //data set waves
					//out of range selection
					
					GetWindow NTP#Nav#Viewer hide
					If(V_Value == 1)
						DisplayWaveNote(listWave,selWave)
						AppendToViewer(listWave,selWave)
					Else
						AppendToViewer(listWave,selWave)
					EndIf
					
					If(row > DimSize(listWave,0) - 1)
						//change the list box focus still
						changeFocus("DataSet",1)
					
						//Delete full path wave text
						DrawAction/W=NTP getGroup=fullPathText,delete
						
						return 0
					EndIf
					
					//change the list box focus
					If(!cmpstr(listFocus,"WaveMatch"))
						changeFocus("DataSet",1)
					EndIf

					drawFullPathText()
		
					break
			endswitch
			break
		case 4: // cell selection
		case 5: // cell selection plus shift key
			If(HandleLBSelection(lba.ctrlName,listWave,row,lba.mouseLoc.h,lba.mouseLoc.v,lba.eventMod))
				print "SELECTION CHANGE ERROR"
			EndIf
			
			
			//Only selection updates for keyboard triggered selections
			If(lba.eventMod != 1)
//				If(!cmpstr(lba.ctrlName,"MatchListBox") || !cmpstr(lba.ctrlName,"DataSetWavesListBox"))
//					DrawAction/W=NTP getGroup=fullPathText,delete
//					SetDrawEnv/W=NTP fname=$LIGHT,fstyle=2,fsize=10,xcoord=abs,ycoord=abs,textxjust= 0,gname=fullPathText,gstart
//					DrawText/W=NTP 14,464,listWave[row][0][1]
//					SetDrawEnv/W=NTP gstop
//				EndIf
				
				GetWindow NTP#Nav#Viewer hide
				If(V_Value == 1)
					DisplayWaveNote(listWave,selWave)
					AppendToViewer(listWave,selWave)
				Else
					AppendToViewer(listWave,selWave)
				EndIf
				
			EndIf
			break
		case 6: // begin edit
		
			break
		case 7: // finish edit
			break
		case 12: //keyboard
		
			If(!cmpstr(lba.ctrlName,"DataSetNamesListBox"))
				hookResult = 1
				return hookResult
			EndIf
			
			//Detect ASCII for 'w' or 'q' 
			//'q' jumps to previous waveset
			//'w' jumpts to next waveset
			Variable i
			If(row == 113 || row == 81)
				//JUMP TO PREVIOUS WAVE SET
				
				//Find the first row that is selected, and find the first wave set before or after that
				If(sum(lba.selWave) > 0)
					For(i=0; i < DimSize(lba.selWave,0); i+= 1)
						If(lba.selWave[i] > 0)
							
							If(row == 119 || row == 87) 	//w
								Variable index = i + 1
							ElseIf(row == 113|| row == 81) //q
								index = i - 1
							EndIf
							break
						EndIf
					EndFor
				Else
					index = 0
				EndIf			
			
				If(row == 113) // no shift, erase other selection
					lba.selWave = 0
				EndIf
				
				//Find the surrounding wave set
				For(i=index;i>-1;i-=1)
					If(stringmatch(lba.listWave[i][0][0],"*WAVE SET*")) 
						lba.selWave[i] = 1
						break
					EndIf
				EndFor
				
			ElseIf(row == 119 || row == 87)
				//JUMP TO NEXT WAVE SET
				
				//Find the last row that is selected, and find the first wave set after that
				If(sum(lba.selWave) > 0)
					For(i=DimSize(lba.selWave,0) - 1; i > - 1; i-= 1)
						If(lba.selWave[i] > 0)	
							If(row == 119 || row == 87) 	//w
								index = i + 1
							EndIf
							break
						EndIf
					EndFor
				Else
					index = 0
				EndIf			
						
				If(row == 119) // no shift
					lba.selWave = 0
				EndIf
									
				//Find the surrounding wave set
				For(i=index;i<DimSize(lba.selWave,0);i+=1)
					If(stringmatch(lba.listWave[i][0][0],"*WAVE SET*")) 
						lba.selWave[i] = 1
						break
					EndIf
				EndFor
							
			EndIf
			
			ListBox $lba.ctrlName win=NTP#Data,row=i
			
			If(HandleLBSelection(lba.ctrlName,listWave,i,lba.mouseLoc.h,lba.mouseLoc.v,lba.eventMod))
				print "SELECTION CHANGE ERROR"
			EndIf

			break
		case 13: // checkbox clicked (Igor 6.2 or later)
			break
	endswitch   
	
	return 1
End

//Handles list box selections
Function HandleLBSelection(ctrlName,listWave,row,mouseHor,mouseVert,eventMod)
	String ctrlName
	Wave/T listWave
	Variable row,mouseHor,mouseVert,eventMod
	
	Variable errorCode = 0
	DFREF NPC = $CW
	DFREF NPD = $DSF
	
	SVAR listFocus = NPC:listFocus
	
	strswitch(ctrlName)
		case "matchListBox": //wave matches
			Wave/T MatchLB_ListWave = NPC:MatchLB_ListWave
			Wave MatchLB_SelWave = NPC:MatchLB_SelWave
			
			//out of range selection
			If(row > DimSize(listWave,0) - 1)
				//change the list box focus still
				changeFocus("WaveMatch",1)
				
				//Delete full path wave text
				DrawAction/W=NTP getGroup=fullPathText,delete
				return 0
			EndIf
			
			If(eventMod == 16 || eventMod == 17)
				//GOTO selected wave contextual menu
				PopupContextualMenu/C=(mouseHor, mouseVert) "GoTo;Edit;Delete;Display;"
				If(V_flag)
					HandleRightClick("matchListBox",V_flag,row=row)
				EndIf
			EndIf
			
			//change the list box focus
			If(!cmpstr(listFocus,"DataSet"))
				changeFocus("WaveMatch",1)
			EndIf
					
//			NVAR viewerOpen = NPC:viewerOpen
//			If(viewerOpen)
			If(eventMod == 0)				
				GetWindow NTP#Nav#Viewer hide
				If(V_Value == 1)
					DisplayWaveNote(MatchLB_ListWave,MatchLB_SelWave)
					AppendToViewer(MatchLB_ListWave,MatchLB_SelWave)
				Else
					AppendToViewer(MatchLB_ListWave,MatchLB_SelWave)
				EndIf
			EndIf
					
			break
		case "dataSetWavesListBox": //data set waves
			//out of range selection
			If(row > DimSize(listWave,0) - 1)
				//change the list box focus still
				changeFocus("DataSet",1)
			
				//Delete full path wave text
				DrawAction/W=NTP getGroup=fullPathText,delete
				
				return 0
			EndIf
			
			If(eventMod == 16 || eventMod == 17)
				//GOTO selected wave contextual menu
				PopupContextualMenu/C=(mouseHor, mouseVert) "GoTo;Edit;Delete;Display;"
				If(V_flag)
					HandleRightClick("dataSetWavesListBox",V_flag,row=row)
				EndIf
			EndIf
			
			//change the list box focus
			If(!cmpstr(listFocus,"WaveMatch"))
				changeFocus("DataSet",1)
			EndIf
					
			//display the full path to the wave in a text box
			Wave/T DataSetLB_ListWave = NPD:DataSetLB_ListWave
			Wave DataSetLB_SelWave = NPD:DataSetLB_SelWave
			
			
//			NVAR viewerOpen = NPC:viewerOpen
			If(eventMod == 0)
				GetWindow NTP#Nav#Viewer hide
				If(V_Value == 1)
					DisplayWaveNote(DataSetLB_ListWave,DataSetLB_SelWave)
					AppendToViewer(DataSetLB_ListWave,DataSetLB_SelWave)
				Else
					AppendToViewer(DataSetLB_ListWave,DataSetLB_SelWave)
				EndIf
			EndIf

			
			break
		case "dataSetNamesListBox": //data set names
						
			If(eventMod == 16 || eventMod == 17)
				//If the right click happens on a non-previously selected data set,
				//first loads those data set setttings into the GUI controls
				If(row > DimSize(listWave,0) - 1)	
					return 0
				EndIf
				
				changeDataSet(listWave[row][0][0])
					
				//GOTO selected wave contextual menu
				PopupContextualMenu/C=(mouseHor,mouseVert) "Send To WaveMatch;"
				If(V_flag)
					HandleRightClick("dataSetNamesListBox",V_flag,row=row)
				EndIf
			Else
			
				//change the list box focus
				If(!cmpstr(listFocus,"WaveMatch"))
					changeFocus("DataSet",1)
				EndIf
				
				//correct row if we selected outside of the listbox limits
				If(row > DimSize(listWave,0) - 1 && DimSize(listWave,0) > 0)	
					row = DimSize(listWave,0) - 1
				EndIf
				
				changeDataSet(listWave[row][0][0])		
			EndIf
			
			break
		case "folderListBox":  //folder navigation
			//out of range selection
			If(row > DimSize(listWave,0) - 1)
				return 0
			EndIf
			
			If(eventMod == 16 || eventMod == 17)
				//GOTO selected wave contextual menu
				PopupContextualMenu/C=(mouseHor, mouseVert) "GoTo;"
				If(V_flag)
					HandleRightClick("folderListBox",V_flag,row=row)
				EndIf
			EndIf
			break
		case "waveListBox":	//waves navigation
			Wave/T WavesLB_ListWave = NPC:WavesLB_ListWave
			Wave WavesLB_SelWave = NPC:WavesLB_SelWave
			
			//out of range selection
			If(row > DimSize(listWave,0) - 1)
				return 0
			EndIf
			
			If(eventMod == 16 || eventMod == 17)
				//GOTO selected wave contextual menu
				PopupContextualMenu/C=(mouseHor, mouseVert) "GoTo;Edit;Delete;Display;"
				If(V_flag)
					HandleRightClick("waveListBox",V_flag,row=row)
				EndIf
			EndIf
			
//			NVAR viewerOpen = NPC:viewerOpen
//			If(viewerOpen)
//				AppendToViewer(WavesLB_ListWave,WavesLB_SelWave)
//			EndIf
			
			break
		case "fileListBox":
			//browse files on disk for wavesurfer or pclamp loading
			Variable fileID
			
			SVAR wsFilePath = NPC:wsFilePath
			SVAR wsFileName = NPC:wsFileName
			
			If(row > DimSize(listWave,0) -1)
				return 0
			EndIf
			
			wsFileName = listWave[row]
			String fullPath = wsFilePath + wsFileName
			
			//What file type are we opening?
			ControlInfo/W=NTP fileType
			String fileType = S_Value
			
			strswitch(fileType)
				case "WaveSurfer":
					HDF5OpenFile/R fileID as fullPath
			
					If(V_flag == -1) //cancelled
						break
					EndIf
					
					//Save the path and filename
					wsFilePath = S_path
					wsFileName = S_fileName
					
					UpdateWaveSurferLists(fileID,wsFilePath,wsFileName)
					
					GetStimulusData(fileID)

					HDF5CloseFile/A fileID
					break
				case "PClamp":
//					Variable refnum
//					fullPath = RemoveEnding(fullPath,".abf") + ".abf"
//					Open/R/Z=2 refnum as fullPath
//
//					fSetPos refnum,12
//					
//					Variable numSweeps = 0					
//					FBInRead/B=3/F=3/U refnum,numSweeps
//					
//					Wave/T wsSweepListWave = NPC:wsSweepListWave
//					Redimension/N=(numSweeps) wsSweepListWave
//					
//					Variable i
//					For(i=0;i<numSweeps;i+=1)
//						wsSweepListWave[i] = "Sweep " + num2str(i + 1)
//					EndFor
//					
//					Close refnum
					break
				case "Presentinator":
					break
			endswitch
			break
	endswitch
	return errorCode
End

//Handles list box right clicks
Function HandleRightClick(controlName,command,[row])
	String controlName
	Variable command,row
	DFREF NPC = $CW
	DFREF NPD = $DSF
	
	STRUCT filters filters
	SVAR listFocus = NPC:listFocus
	
	Variable errorCode = 0
	strswitch(controlName)
		case "dataSetWavesListBox": //data set waves
			//Get the full path list wave for the selected data set
			String dsName = GetDSName()
			
			Wave/T listWave = GetDataSetWave(dsName,"ORG")
			
			//out of range selection
			If(row > DimSize(listWave,0) - 1)
				return 0
			EndIf
			
			//Selected wave in the data set waves list box
			String list = listWave[row][0][1]
			
			//If a wave set was selected
			If(stringmatch(list,"*WAVE SET*"))
				Variable wsn = str2num(StringByKey("WAVE SET",list," ","-"))
				Wave/T ws = GetWaveSet(listWave,wsn)
				DeletePoints/M=2 0,1,ws
				list = TextWaveToStringList(ws,";")
			EndIf
			
			doRightClickAction(command,list)
			
			break
		case "dataSetNamesListBox": //data set names
			//Right click sends the selected data set's filters, groups, and 
			//original wave match settings to the WaveMatch list
			
			Wave/T DSNamesLB_ListWave = NPD:DSNamesLB_ListWave
			Variable index = GetDSIndex()
			
			If(index != -1)
				//Save the current filters/grouping settings
				If(!cmpstr(listFocus,"DataSet"))
					saveFilterSettings("DataSet")
				EndIf
							
				//Puts the saved filter settings into the GUI controls
				recallFilterSettings("DataSet")
	
				//Change focus to the WaveMatch list, without doing a save/retrieve
				changeFocus("WaveMatch",0)
				
				//Select the old folders
				SelectFolder(DSNamesLB_ListWave[index][0][2])
				
				//Put the original filter settings into the control panel
				RecallOriginalFilters(DSNamesLB_ListWave[index][0][1])
				
				//With focus on the WaveMatch list, re-run the match/filter/group
				getWaveMatchList()
				
			EndIf
			
			break

		case "matchListBox":
		case "waveListBox":	//waves navigation
			
			//Get a list of the selected waves
			If(!cmpstr(controlName,"matchListBox"))	
				Wave/T listWave = NPC:MatchLB_ListWave
				If(row > DimSize(listWave,0)-1)
					return 0
				EndIf
				
				list = listWave[row][0][1] + ";"
				
				//If a wave set was selected
				If(stringmatch(list,"*WAVE SET*"))
					wsn = str2num(StringByKey("WAVE SET",list," ","-"))
					Wave/T ws = GetWaveSet(listWave,wsn)
					DeletePoints/M=2 0,1,ws
					list = TextWaveToStringList(ws,";")
				EndIf
			
			ElseIf(!cmpstr(controlName,"waveListBox"))
				Wave/T listWave = NPC:WavesLB_ListWave
				If(row > DimSize(listWave,0)-1)
					return 0
				EndIf
				
				String theFolder = GetDataFolder(1)
				list = theFolder + listWave[row][0][1] + ";"
			EndIf
			
			//Perform selected right click action
			doRightClickAction(command,list)
			
	endswitch
	return errorCode
End

//Performs one of the actions in the contextual right click menu
Function doRightClickAction(command,list)
	Variable command
	String list
	
	//which option was clicked?
	switch(command)
		case 1: //GoTo
			Variable i = 0
			
			//Browse to the selected wave
			ModifyBrowser collapseAll//close all folders first
			CreateBrowser //activates the data browser focus
			ModifyBrowser clearSelection,selectList=list //selects waves
			break
		case 2: //Edit
			GetWindow NTP#Data wsize
			Wave theWave = $StringFromList(0,list,";")
			
			If(!WaveExists(theWave))
				return 0
			EndIf
			
			If(!strlen(GetDimLabel(theWave,0,0)))
				Edit/K=1/W=(V_right,V_top,V_right + 200,V_top + 200) theWave
			Else
				Edit/K=1/W=(V_right,V_top,V_right + 200,V_top + 200) theWave.ld
			EndIf
			
			
			break
		case 3: //Delete
			Wave theWave = $StringFromList(0,list,";")
			DoAlert/T="Delete Wave" 1,"Are you sure you want to delete the wave: " + StringFromList(0,list,";") + "?"
			
			If(V_flag == 1)
				ReallyKillWaves(theWave)
			EndIf
			
			CheckDataSetWaves()
			
			GetFolders()
			GetFolderWaves()
			
			break
		case 4: //Display
			GetWindow NTP#Data wsize
			
			Wave theWave = $StringFromList(0,list,";")
			
			If(!WaveExists(theWave))
				return 0
			EndIf
			
			If(WaveType(theWave,1) != 1)
				break
			ElseIf(WaveDims(theWave) == 1) //1D
				Display/W=(V_right,V_top,V_right + 390,V_top + 205)
				For(i=0;i<ItemsInList(list,";");i+=1)
					AppendToGraph $StringFromList(i,list,";")
				EndFor
				
			Else //2D
				NewImage/N=$NameOfWave(theWave) theWave
			EndIf
			break
	endswitch
	
	return 0
End

//Handles list box double clicks
Function HandleLBDoubleClick(lba)
	STRUCT WMListboxAction &lba
	Variable errorCode = 0
	DFREF NPC = $CW
	
	strswitch(lba.ctrlName)
		case "matchListBox": //wave matches
			break
		case "dataSetWavesListBox": //data set waves
			break
		case "dataSetNamesListBox": //data set names
			break
		case "folderListBox":  //folder navigation
			Wave/T FolderLB_ListWave = NPC:FolderLB_ListWave
			If(lba.row < DimSize(FolderLB_ListWave,0))
				switchFolders(FolderLB_ListWave[lba.row])
			EndIf
			break
		case "waveListBox":	//waves navigation
			break
	endswitch
	return errorCode
End

//BUTTONS------------------------------------------------------------
Function ntButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	
	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			//Immediately open the data set name input upon mouse down
			If(!cmpstr(ba.ctrlName,"addDataSet"))
				//animate a text box opening under the button
				SetVariable dsNameInput win=NT,disable=0,activate,value=_STR:"NewDS"
				GroupBox dsNameGroupBox win=NT,disable=0
			EndIf
			
			If(HandleButtonClick(ba))
				print "BUTTON ERROR"
			EndIf
			break	
		case -1: // control being killed
			break
	endswitch

	return 0
End

//Handles button clicks
Function HandleButtonClick(ba)
	STRUCT WMButtonAction &ba
	DFREF NPC = $CW
	DFREF NPD = $DSF
	
	SVAR selectedCmd = NPC:selectedCmd
	Wave/T param = NPC:ExtFunc_Parameters
	
	Variable errorCode = 0
	strswitch(ba.ctrlName)
		
		case "WaveListSelector":
			NVAR foldStatus = NPC:foldStatus
			//Prevents weird bug where the Wave Selector menu opens even though parameter panel is closed
			If(!foldStatus)
				break
			EndIf
			
			PopUpContextualMenu/C=(507,95)/N "WaveListSelectorMenu"
			
			String popStr = S_Selection
			Variable popNum = V_flag
			
			If(V_flag == 0 || V_flag == -1)
				break
			EndIf
	
			//Switches the menu text, center aligned
			switchWaveListSelectorMenu(popStr)
			
			//auto loads the selected data set into the Data Set waves list box
			strswitch(popStr)
				case "Wave Match":
				case "Navigator":
				case "Image Browser":
					break
				default:
					Wave/T DSNamesLB_ListWave = NPD:DSNamesLB_ListWave
					ListBox DataSetNamesListBox win=NTP#Data,selRow=tableMatch(popStr,DSNamesLB_ListWave)
					changeDataSet(popStr)
			endswitch
			break
		case "refreshMenu":
			Wave/T param = NPC:ExtFunc_Parameters
			GetExternalFunctionData(param)
			BuildMenu "FunctionMenu"
		
			BuildExtFuncControls(CurrentExtFunc())
			break
		case "functionPopUp":
			//external functions drop down menu selection
			Wave/T param = NPC:ExtFunc_Parameters
//			GetExternalFunctionData(param)
			
			BuildMenu "FunctionMenu"
			
			SVAR selectedCmd = NPC:selectedCmd
			PopUpContextualMenu/C=(40,62)/W=NTP#Func/N "FunctionMenu"
			
			popStr = S_Selection
			popNum = V_flag
			
			If(V_flag == 0 || V_flag == -1)
				break
			EndIf
			
			SwitchExternalFunction(popStr)
			String func = GetFunctionFromTitle(popStr)
			selectedCmd = func
			
			SVAR currentFunc = NPC:currentFunc
			currentFunc = selectedCmd
			break
		case "gotoFunc": //opens the procedure window of the current external function
			func = CurrentExtFunc()
			DisplayProcedure/W=NTP_ExternalFunctions func
			break
		case "funcNotes":
			func = CurrentExtFunc()
			String functionStr = ProcedureText(func,0)
			String funcNote = GetFunctionNote(functionStr)
			DisplayFunctionNote(func,funcNote)
			break
		case "measureType": //pop up menu for the Measure function 
			PopUpContextualMenu/C=(487,125)/N "MeasureTypeMenu"
			
			popStr = S_Selection
			popNum = V_flag
			
			If(V_flag == 0 || V_flag == -1)
				break
			EndIf
			
			//Calculates spacer to ensure centered text on the drop down menu
			String spacer = ""
			Variable cmdLen = strlen(popStr)
			cmdLen = 15 - cmdLen
			
			Do
				spacer += " "
				cmdLen -= 1
			While(cmdLen > 0)
			
			//switch the text on the button/drop down menu
			Button measureType win=NT,title="\\JL▼   " + spacer + popStr
			
			setupMeasureControls(popStr)
			
			break
		case "runFunc":
			//Starts the series of wrapper functions that will run the specified user function.
			RunCmd(selectedCmd)
			break
		case "scaleFactorUpdate":
			NVAR scaleFactor = root:Packages:NT:Settings:scaleFactor
			DoWindow/F/W=NTP NT
			Variable dpi = ScreenResolution
			dpi = round(dpi * scaleFactor)
			String cmdStr = "SetIgorOption PanelResolution = 72"
			Execute cmdStr
		case "Reload":
			GetWindow NTP wsize
			KillWindow/Z NTP
			LoadNeuroPlus()
			
			DoWindow SI
			If(V_flag)
				KillWindow/Z SI
				LoadScanImagePackage()
			EndIf
			break
		case "Back":
			folderBack()
			break
		case "hideNTP":
			//hide the GUI
			SetWindow NTP,hide=1
			break
		case "NT_Settings":
//			openSettingsPanel()
			break
		case "addDataSet":
			//adds a new data set with the contents of the WaveMatch list box
			SVAR dsNameInput = NPD:dsNameInput
			dsNameInput = ""
			
			//Hide the update and delete data set controls
			Button delDataSet win=NT,disable=1
			Button updateDataSet win=NT,disable=1	
			
			//Wait for user to enter the data set name on mouse up
			Do
				PauseForUser/C NT
			While(!strlen(dsNameInput))
			
			If(addDataSet(dsNameInput))
				print "ADD DATA SET ERROR"
			EndIf
			
			//close the text box
			SetVariable dsNameInput win=NT,disable=1
			GroupBox dsNameGroupBox win=NT,disable=1
			
			//Show the update and delete data set controls
			Button delDataSet win=NT,disable=0
			Button updateDataSet win=NT,disable=0
			break
		case "delDataSet":
			//Deletes a data set
			Wave/T DSNamesLB_ListWave = NPD:DSNamesLB_ListWave
			
			//No data sets exist to be deleted
			If(DimSize(DSNamesLB_ListWave,0) == 0)
				return 0
			EndIf
			
			String dsName = GetDSName()
			
			If(deleteDataSet(dsName))
				print "DELETE DATA SET ERROR"
			EndIf
			
			break
		case "updateDataSet":
			//Updates the selected data set with the contents of the WaveMatch list box
			Wave/T DSNamesLB_ListWave = NPD:DSNamesLB_ListWave
			
			//No data sets exist to be deleted
			If(DimSize(DSNamesLB_ListWave,0) == 0)
				return 0
			EndIf
			
			dsName = GetDSName()
			//Nothing selected
			If(!strlen(dsName))
				return 0
			EndIf
			
			If(updateDataSet(dsName))
				print "UPDATE DATA SET ERROR"
			EndIf
		
			break
		case "clearFilters":
			clearFilterControls()
			break
		case "appendCommand":
			appendCommandLineEntry()
			break
		case "clearCommand":
			clearCommandLineEntry()
			break
//		case "ntViewerButton":
			
//			break
		case "ntViewerAutoScaleButton":
			SetAxis/W=NTP#Nav#Viewer/A
			break
//		case "ntViewerSeparateVertButton":
//			SeparateTraces("vert")
//			break
//		case "ntViewerSeparateHorizButton":
//			SeparateTraces("horiz")
//			break
		case "ntViewerDisplayTracesButton":
			String theTraces = TraceNameList("NTP#Nav#Viewer",";",1)
	
			GetWindow/Z NT wsize
			//Duplicates the Viewer graph outside of the viewer
			String winRec = WinRecreation("NTP#Nav#Viewer",0)
			
			Variable pos1 = strsearch(winRec,"/W",0)
			Variable pos2 = strsearch(winRec,"/FG",0) - 1
			
			String matchStr = winRec[pos1,pos2]
			winRec = ReplaceString(matchStr,winRec,"/W=(" + num2str(V_right+10) + "," + num2str(V_top) + "," + num2str(V_right+360) + "," + num2str(V_top+200) + ")")
			winRec = ReplaceString("/FG=(FL,VT,FR,VB)/HOST=#",winRec,"")
			Execute/Q/Z winRec
			break
		case "ntViewerClearTracesButton":
			clearTraces()
			NVAR areHorizSeparated = NPC:areHorizSeparated
			NVAR areVertSeparated = NPC:areVertSeparated
			areHorizSeparated = 0
			areVertSeparated = 0
			break
		case "BrowseFiles":
			//browse files on disk for wavesurfer loading
			Variable fileID
			
			SVAR wsFilePath = NPC:wsFilePath
			SVAR wsFileName = NPC:wsFileName
			
			//What file type are we opening?
			ControlInfo/W=NTP fileType
			String fileType = S_Value
			
			BrowseEphys(fileType)
			
			break
		case "copyToClipboard":
			Wave/T savedNameTable = NPC:savedNameTable
			ControlInfo/W=NTP savedNames
			
			Variable index = tablematch(S_Value,savedNameTable)
			
			If(index == -1)
				String str = ""
			Else
				str = savedNameTable[index][1]
			EndIf
			
			//Copy the string to the clipboard
			PutScrapText str
			break
		case "editSaveNames":
			Wave/T savedNameTable = NPC:savedNameTable
			If(!WaveExists(savedNameTable))
				Make/N=(0,2)/T/O NPC:savedNameTable /Wave = savedNameTable
			EndIf
			
			Edit savedNameTable
			break
		case "deleteSuffix":
			RunCmd("delSuffix")
			break
	endswitch
	return errorCode
End

//SET VARIABLES------------------------------------------------------------

Function ntSetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	STRUCT filters filters
	
	DFREF NPC = $CW
	DFREF NPD = $DSF
	SVAR listFocus = NPC:listFocus
	
	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
			Variable dval = sva.dval
			String sval = sva.sval
			
			strswitch(sva.ctrlName)
				case "waveMatch":
				case "waveNotMatch":
				case "relativeFolderMatch":
					//Save the current filters/grouping settings before changing focus
					If(!cmpstr(listFocus,"DataSet"))
						saveFilterSettings("DataSet")
					EndIf
					
					//Don't recall previous settings, bc we just changed it.
					changeFocus("WaveMatch",0)
					
				case "waveGrouping":
				case "prefixGroup":
				case "groupGroup":
				case "seriesGroup":
				case "sweepGroup":
				case "traceGroup":	
				case "pos6Group":
				case "pos7Group":				
					//Builds the match list according to all search terms, groupings, and filters
					getWaveMatchList()
					
					//display the full path to the wave in a text box
					drawFullPathText()
					
					break
				case "dsNameInput":
					SVAR dsNameInput = NPD:dsNameInput
					dsNameInput = sval
					break
				case "cmdLineStr":
					SVAR masterCmdLineStr = NPC:masterCmdLineStr
					NVAR editingMasterCmdLineStr = NPC:editingMasterCmdLineStr
					
					//break if not in editing mode
					If(editingMasterCmdLineStr == -1)
						break
					EndIf
					
					//If we're in editing mode
					//Replace the specified entry
					masterCmdLineStr = ReplaceListItem(editingMasterCmdLineStr,masterCmdLineStr,";/;",sval)
					
					//ensure that the correct separator is on the end
					masterCmdLineStr = RemoveEnding(masterCmdLineStr,";/;") + ";/;"
					
					//Redraw the command list entries
					DrawMasterCmdLineEntry()
					
					//reset the editing mode
					editingMasterCmdLineStr = -1
					break
			endswitch
		case 3: // Live update
			
			break
		case -1: // control being killed
			break
		case -3: //received keyboard focus (Igor 8 and above only)
			strswitch(sva.ctrlName)
				case "waveMatch":
				case "waveNotMatch":
				case "relativeFolderMatch":
					changeFocus("WaveMatch",1)
					break
			endswitch
			break
	endswitch

	return 0
End



//Handles variable, string, and wave inputs to external function parameter inputs
Function ntExtParamProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva
	DFREF NPC = $CW
	
	//holds the parameters of the external functions
	Wave/T param = NPC:ExtFunc_Parameters
	
	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
			Variable dval = sva.dval
			String sval = sva.sval
			
			String name = sva.ctrlName
			Variable paramIndex = ExtFuncParamIndex(name)
			
			
			String func = CurrentExtFunc()
			String type = getParam("PARAM_" + num2str(paramIndex) + "_TYPE",func)
			
			strswitch(type)
				case "4"://variable
					setParam("PARAM_" + num2str(paramIndex) + "_VALUE",func,num2str(dval))
					break
				case "8192"://string
					If(stringmatch(name,"*_args"))
						setParam("PARAM_" + num2str(paramIndex) + "_ARGS",func,sval)
					Else
						setParam("PARAM_" + num2str(paramIndex) + "_VALUE",func,sval)
					EndIf
					break
				case "16386"://wave
					setParam("PARAM_" + num2str(paramIndex) + "_VALUE",func,sval)
					String ctrlName = sva.ctrlName
					//confirm validity of the wave reference
					validWaveText("",0,deleteText=1,parentCtrl=ctrlName)
					ControlInfo/W=NTP#Func $sva.ctrlName
					validWaveText(sval,V_top+13,parentCtrl=ctrlName)
					break
			endswitch
		case 3: // Live update
			
			break
		case -1: // control being killed
			break
	endswitch	
	return 0
End

//Handles external function checkboxes
Function ntExtParamCheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba
	
	String name = cba.ctrlName
	Variable paramIndex = ExtFuncParamIndex(name)
	
	String func = CurrentExtFunc()
	String type = getParam("PARAM_" + num2str(paramIndex) + "_TYPE",func)
			
	switch( cba.eventCode )
		case 2: // mouse up
			Variable checked = cba.checked
			setParam("PARAM_" + num2str(paramIndex) + "_VALUE",func,num2str(checked))
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End


//POP UP MENUS---------------------------
Function ntPopMenuProc(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			
			strswitch(pa.ctrlName)
				case "WaveListSelector":
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function ntExtParamPopProc(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			
			//Set the value of the external function parameter
			DFREF NPC = $CW
			Wave/T param = NPC:ExtFunc_Parameters
			
			String func = CurrentExtFunc()
			Variable index = ExtFuncParamIndex(pa.ctrlName)
			
			setParam("PARAM_" + num2str(index) + "_VALUE",func,popStr)
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

//CONTEXTUAL MENUS (initiated through button clicks)
Function ntContextualMenuProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	
	DFREF NPC = $CW
	DFREF NPD = $DSF
	
	DFREF NPC = $CW
	Wave/T param = NPC:ExtFunc_Parameters
			
	Variable errorCode = 0
	switch(ba.eventCode)
		case 2: // mouse up
			Variable index = ExtFuncParamIndex(ba.ctrlName)
			
			String funcLabel = CurrentExtFunc()
			String paramLabel = "PARAM_" + num2str(index) + "_ITEMS"
			
			String contextualMenu = param[%$paramLabel][%$funcLabel]
			
			If(!strlen(contextualMenu))
				break
			EndIf
			
			ControlInfo/W=NTP#Func $ba.ctrlName
			Variable left = V_left
			Variable top = V_top + 22
			Variable width = V_width
			
			PopUpContextualMenu/W=NTP#Func/C=(left,top)/N contextualMenu
			
			If(V_flag == -1) 
				return 0
			EndIf
			
			//Set the value of the selection to the param table
			setParam("PARAM_" + num2str(index) + "_VALUE",funcLabel,S_Selection)
			
			String spacedStr = getSpacer(S_Selection,18)
			
			Button $ba.ctrlName win=NTP#Func,title = spacedStr
			
			break
	endswitch
	
	return 0
End

//CHECK BOXES -----------------------------

Function ntCheckProc(ca) : CheckBoxControl
	STRUCT WMCheckBoxAction &ca
	
	DFREF NPC = $CW
	
	NVAR areHorizSeparated = NPC:areHorizSeparated
	NVAR areVertSeparated = NPC:areVertSeparated
	
	switch( ca.eventCode )
		case 2: // mouse up
			strswitch( ca.ctrlName)
				case "ntViewerSeparateVert":
				
					//Remove any horizontal separation
					Checkbox ntViewerSeparateHoriz win=NT,value=0
					areHorizSeparated = 0
					SeparateTraces("horiz")

					If(ca.checked)
						areVertSeparated = 1
					Else
						areVertSeparated = 0
					EndIf
					
					//Apply or remove vertical separations
					SeparateTraces("vert")
					
					break
				case "ntViewerSeparateHoriz":
				
					//Remove any vertical separation
					Checkbox ntViewerSeparateVert win=NT,value=0
					areVertSeparated = 0
					SeparateTraces("vert")
					
					If(ca.checked)
						areHorizSeparated = 1
					Else
						areHorizSeparated = 0
					EndIf
					
					//Apply or remove horizontal separations
					SeparateTraces("horiz")
					
					break			
			endswitch
			
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End






//CUSTOM HOOK FUNCTIONS------------------------------------------------------------

//Hook function to initiate animated fold or unfold of the parameter panel
//Triggers the hook if the mouse is clicked on the vertical thick divider in the GUI
Function MouseClickHooks(s)
	STRUCT WMWinHookStruct &s
	DFREF NPC = $CW
	DFREF NTS = root:Packages:NT:Settings
	NVAR foldStatus = NPC:foldStatus
	
	NVAR hf = NTS:hf
	
	Variable hookResult = 0
	Variable r = ScreenResolution / 72
	
	
	switch(s.eventCode)
		case 0:
			//handle activate
			break
		case 1: 
			//handle deactivate
			break
//		case 17:
//			//kill window catch, hide instead
//			SetWindow NTP hide=1
//			return 2
		case 3:
			//handle mouse down

			GetMouse/W=NTP#Data
			
			//mouse hook for toggling the listbox focus	
			If(V_left > 10 && V_left < 235 && V_top > 130 && V_top < 160) //Wave Match Click
				changeFocus("WaveMatch",1)
			ElseIf(V_left > 245 && V_left < 470 && V_top > 130 && V_top < 160) //Data Set Click
				changeFocus("DataSet",1)
			EndIf
			break
			
		case 4:
			//mouse moved
			NVAR WM_Position = NPC:WM_Position
			NVAR DSW_Position = NPC:DSW_Position
			NVAR WM_Resize = NPC:WM_Resize
			NVAR DS_Resize = NPC:DS_Resize
			NVAR Waves_Resize = NPC:Waves_Resize
			NVAR Folders_Resize = NPC:Folders_Resize
			NVAR Folders_Position = NPC:Folders_Position
			NVAR hf =  NTS:hf
			
			//Wave Match Hover
			If(s.mouseLoc.h < WM_Position + 5 && s.mouseLoc.h > WM_Position - 5 && s.mouseLoc.v > 123 && s.mouseLoc.v <  452)
				//Change the cursor to the left right drag icon
				s.doSetCursor = 1
				s.cursorCode = 5
				
			//Navigator Folders Hover
			ElseIf(s.mouseLoc.h < Folders_Position + 5 && s.mouseLoc.h > Folders_Position - 5 && s.mouseLoc.v > 72)	
				//Change the cursor to the left right drag icon
				s.doSetCursor = 1
				s.cursorCode = 5
			EndIf
			
			If(WM_Resize)
				//Change the cursor to the left right drag icon
				s.doSetCursor = 1
				s.cursorCode = 5 
				
				If(s.mouseLoc.h < 80 || s.mouseLoc.h > 260)
					
					ControlInfo/W=NTP MatchListBox
					WM_Position = V_width + 6
					break
				EndIf
				
				ControlInfo/W=NTP MatchListBox
				ListBox MatchListBox win=NT,size={s.mouseLoc.h - 6,V_height}
				
				ControlInfo/W=NTP DataSetWavesListBox
				ListBox DataSetWavesListBox win=NT,pos={s.mouseLoc.h + 5,V_top},size={V_right - s.mouseLoc.h - 5,V_height}
				
				WM_Position = s.mouseLoc.h
				
				//move the focus box with it
				SVAR listFocus = NPC:listFocus
				strswitch(listFocus)
					case "WaveMatch":
						listFocus = "DataSet"
						changeFocus("WaveMatch",1)
						break
					case "DataSet":
						listFocus = "WaveMatch"
						changeFocus("DataSet",1)
						break
				endswitch
			ElseIf(Folders_Resize)
				//Change the cursor to the left right drag icon
				s.doSetCursor = 1
				s.cursorCode = 5
				
				//Mouse position in navigator panel coordinates
				GetMouse/W=NTP#navigatorPanel
				Variable mouseHor = V_left
				
				ControlInfo/W=NTP#navigatorPanel folderListBox
				Variable xExpand = mouseHor - V_right
				
				If(mouseHor < 60 || mouseHor > 220)
					break
				EndIf
				
				ListBox folderListBox win=NT#navigatorPanel,size={V_width + xExpand,V_height}
				
				Folders_Position += xExpand
				 
				ControlInfo/W=NTP#navigatorPanel waveListBox
				ListBox waveListBox win=NT#navigatorPanel,pos={V_left + xExpand,V_top},size={V_width - xExpand,V_height}	
				
			EndIf

			break
		case 5:
			//mouse up
			
			GetWindow/Z NTP activeSW
			If(!cmpstr(S_Value,"NTP#Func#DSNotebook"))
				DoWindow/W=NTP#Corner NTP
			EndIf
			
			NVAR WM_Position = NPC:WM_Position
			NVAR DSW_Position = NPC:DSW_Position
			NVAR WM_Resize = NPC:WM_Resize
			NVAR DS_Resize = NPC:DS_Resize
			NVAR Folders_Resize = NPC:Folders_Resize
			
			//Change the cursor to the left right drag icon
			s.doSetCursor = 1
			s.cursorCode = 0
			Folders_Resize = 0
			
			//Wave Match Hover
			If(WM_Resize)
				//Change the cursor to the left right drag icon
				s.doSetCursor = 1
				s.cursorCode = 0
				
				ControlInfo/W=NTP MatchListBox
				WM_Position = V_width + 6
				
				WM_Resize = 0
				hookResult = 1
			EndIf
			
			break

	endswitch

	return hookResult
End

//Window hook for the Viewer
//Handles trace selections and horizontal shifting
//Function viewerHook(s)
//	STRUCT WMWinHookStruct &s
//	DFREF NPC = $CW
//	
//	SVAR selectedTrace = NPC:selectedTrace
//	SVAR selectedAxis = NPC:selectedAxis
//	
//	Variable hookResult = 0
//	Variable r = ScreenResolution / 72
//	
//	switch(s.eventCode)
//		case 0:
//			//handle activate
//			break
//		case 1: 
//			//handle deactivate
//			break
//		case 5:
//			//handle mouse up
//			GetMouse/W=NTP
//			If(V_top > 515 && V_top < 515 + 300 - 25)
//				If(strlen(selectedTrace))
//					ModifyGraph/W=NTP#Nav#Viewer lsize($selectedTrace)=1
//				EndIf
//				
//				String trace = TraceFromPixel(V_left,V_top,"WINDOW:NTP#Nav#Viewer;DELTAX:3;DELTAY:3")
//				trace = StringByKey("TRACE",trace)
//				
//				If(strlen(trace))
//					selectedTrace = trace
//					String axis = TraceInfo("NTP#Nav#Viewer",trace,0)
//					selectedAxis = StringByKey("/B",StringByKey("AXISFLAGS",axis),"=")
//					ModifyGraph/W=NTP#Nav#Viewer lsize($trace)=2
//				Else
//					selectedTrace = ""
//					selectedAxis = ""
//				EndIf
//			EndIf
//			hookResult = 1
//			break
//		case 11:
//			//handle keyboard input
//			If(strlen(selectedTrace) && strlen(selectedAxis))
//				Variable axisNum = str2num(StringFromList(1,selectedAxis,"_"))	
//				String list = AxisList("NTP#Nav#Viewer")
//				list = ListMatch(list,"bottom*",";")
//				
//				//wave ref for the trace we're moving
//				Wave selectedTraceWave = TraceNameToWaveRef("NTP#Nav#Viewer",selectedTrace)
//				
//				If(!strlen(list))
//					break
//				EndIf
//					
//				switch(s.keyCode)
//					case 28: //left arrow	
//						String newAxis = ReplaceListItem(1,selectedAxis,"_",num2str(axisNum - 1))
//						//If we are on the first axis moving left, wrap around to the right side
//						If(WhichListItem(newAxis,list) == -1)
//							newAxis = StringFromList(ItemsInList(list,";")-1,list,";")
//							Variable isWrap = 1
//						Else
//							isWrap = 0
//						EndIf
//						
//						//trace that is currently on the axis we're moving to
//						String traceOnNewAxis = AxisInfo("NTP#Nav#Viewer",newAxis)
//						traceOnNewAxis = StringByKey("CWAVE",traceOnNewAxis)
//						
//						//wave ref for the trace we're replacing
//						Wave traceOnNewAxisWave = TraceNameToWaveRef("NTP#Nav#Viewer",traceOnNewAxis)
//				
//						//Flip the traces, requires reordering traces as they are added/removed			
//						ReplaceWave/W=NTP#Nav#Viewer trace=$traceOnNewAxis,selectedTraceWave
//						
//						AppendToGraph/W=NTP#Nav#Viewer/B=$selectedAxis traceOnNewAxisWave
//						
//						If(isWrap)
//							ReorderTraces/W=NTP#Nav#Viewer _front_,{$selectedTrace}
//							ReorderTraces/W=NTP#Nav#Viewer _back_,{$traceOnNewAxis}
//						Else
//							ReorderTraces/W=NTP#Nav#Viewer $selectedTrace,{$selectedTrace,$traceOnNewAxis}					
//						EndIf
//						
//						RemoveFromGraph	/W=NTP#Nav#Viewer $(selectedTrace + "#1")					
//
//						//Bolden line to indicate selected trace
//						ModifyGraph/W=NTP#Nav#Viewer lsize($selectedTrace)=2
//						
//						//Change selected axis
//						selectedAxis = newAxis				
//						break
//					case 29: //right arrow
//						newAxis = ReplaceListItem(1,selectedAxis,"_",num2str(axisNum + 1))
//						//If we are on the last axis moving right, wrap around to the left side
//						If(WhichListItem(newAxis,list) == -1)
//							newAxis = StringFromList(0,list,";")
//							isWrap = 1
//						Else
//							isWrap = 0
//						EndIf
//						
//						//trace that is currently on the axis we're moving to
//						traceOnNewAxis = AxisInfo("NTP#Nav#Viewer",newAxis)
//						traceOnNewAxis = StringByKey("CWAVE",traceOnNewAxis)
//						
//						//wave ref for the trace we're replacing
//						Wave traceOnNewAxisWave = TraceNameToWaveRef("NTP#Nav#Viewer",traceOnNewAxis)
//					
//						//Flip the traces, requires reordering traces as they are added/removed						
//						ReplaceWave/W=NTP#Nav#Viewer trace=$traceOnNewAxis,selectedTraceWave
//						AppendToGraph/W=NTP#Nav#Viewer/B=$selectedAxis traceOnNewAxisWave	 
//												
//						If(isWrap)
//							RemoveFromGraph	/W=NTP#Nav#Viewer $(selectedTrace + "#1")
//						Else
//							ReorderTraces/W=NTP#Nav#Viewer $selectedTrace,{$traceOnNewAxis,$selectedTrace}
//							RemoveFromGraph	/W=NTP#Nav#Viewer $selectedTrace
//						EndIf
//						
//						//Bolden line to indicate selected trace
//						ModifyGraph/W=NTP#Nav#Viewer lsize($selectedTrace)=2
//						
//						//Change selected axis
//						selectedAxis = newAxis	
//						break
//				endswitch
//				
//			EndIf
//			hookResult = 1
//			break
//	endswitch
//	return hookResult
//End

//Opens the parameter infold opening
Function openParameterFold([size])
	Variable size
	
	DFREF NPC =  root:Packages:NT:
	SVAR listFocus = NPC:listFocus
	NVAR Folders_Position = NPC:Folders_Position
	NVAR ppr = root:Packages:NT:Settings:ppr//pixel shift per refresh; can adjust Settings panel
	
	If(ParamIsDefault(size))
		size = 210
	EndIf
	
	//Show the command menu and run button
	Button CommandMenu win=NT,disable=0
	Button RunCmd win=NT,disable=0
		
	//expand group box first
	GroupBox parameterBox win=NT,pos={455,69},size={size-13,437}
	
	//shift text label
	SetDrawEnv/W=NTP  fstyle= 0
	DrawAction/W=NTP delete,getgroup=parameterText
	SetDrawEnv/W=NTP xcoord= abs,ycoord= abs, fsize=14, textrgb= (0,0,0), textxjust= 1,textyjust= 1,fname=$LIGHT,gstart,gname=parameterText
	DrawText/W=NTP 455+(size/2)-6,15,"Parameters"
	SetDrawEnv/W=NTP gstop
	
	//Draw the help message
	SVAR selectedCmd = NPC:selectedCmd	
//	switchHelpMessage(selectedCmd)
	
	Variable r = ScreenResolution/72
	Variable delta = ppr/r
	
	Do
		Variable i
	
		//Get original window coordinates
		GetWindow NT wsize
		Variable left,top,right,bottom
		left = V_left;right=V_right;top=V_top;bottom=V_bottom
		Variable expansion = (right*r - left*r) - 754 //current expansion relative to original width of the panel
		
		If(expansion >= size)
			ControlInfo/W=NTP#navigatorPanel folderListBox
			Folders_Position = 460 + V_width + size
			break
		EndIf
		
		Variable pixelsLeft = size - expansion
		If(pixelsLeft < ppr)
			MoveWindow/W=NTP left,top,right+(pixelsLeft/r),bottom;DelayUpdate
			Variable shift = size
		Else
			//Extend right edge of the panel to make room
			MoveWindow/W=NTP left,top,right+delta,bottom;DelayUpdate
			shift = expansion + delta
		EndIf
				
		//Shift the right line
		SetDrawEnv/W=NTP  fstyle= 0
		DrawAction/W=NTP delete,getgroup=rightLine
		SetDrawEnv/W=NTP xcoord= abs,ycoord= abs,linefgc= (0,0,0,16384),linethick= 4,gname=rightLine,gstart
		DrawLine/W=NTP 448 + shift,0, 448 + shift,515;DelayUpdate
		SetDrawEnv/W=NTP gstop
		
		DoUpdate/W=NTP
	While(expansion <= size)
	
	SVAR loadedPackages = NPC:loadedPackages
	
	//Special case enabling and disabling
	strswitch(selectedCmd)
		case "Run Cmd Line":
		case "New Data Folder":
		case "Load Suite2P":
		case "Kill Data Folder":
			break
		case "Load Scans":
			ListBox scanLoadListbox, win=NT,disable=0
			break
		case "External Function":
			BuildExtFuncControls(CurrentExtFunc())
			Button WaveListSelector win=NT,disable=3
			break
		case "Load Ephys":
		case "Load WaveSurfer":
//			ListBox sweepListBox win=NT,disable=0
			ListBox fileListBox win=NT,disable=0
			Button WaveListSelector win=NT,disable=3
			ListBox stimulusData win=NT,disable=0
			
			break
		case "Load pClamp":
			ListBox fileListBox win=NT,disable=0
			Button WaveListSelector win=NT,disable=3
			ListBox sweepListBox win=NT,disable=0
			break
		case "Population Vector Sum":
			break
		case "Get ROI":
			//only if this is 2PLSM package, not scanimage package
			If(stringmatch(loadedPackages,"*Imaging*"))
				ListBox ROIListBox win=NT,disable=0
				Button WaveListSelector win=NT,disable=3
			EndIf
			break
		default:
			Button WaveListSelector win=NT,disable=0
			break
	endswitch
	
End

//Closes the parameter infold
Function closeParameterFold([size])
	Variable size
	DFREF NPC =  root:Packages:NT:
	
	NVAR ppr = root:Packages:NT:Settings:ppr //pixel shift per refresh; can adjust in Settings panel
	NVAR Folders_Position = NPC:Folders_Position
	SVAR selectedCmd = NPC:selectedCmd	
	
	Variable r = ScreenResolution/72
	Variable delta = ppr/r
	
	If(ParamIsDefault(size))
		size = 0
		
		//hide the command menu, run cmd button, and ROIListBox on full closure
		Button CommandMenu win=NT,disable=3
		Button RunCmd win=NT,disable=3
		ListBox ROIListBox win=NT,disable=3
		ListBox sweepListBox win=NT,disable=3
		ListBox fileListBox win=NT,disable=3
		ListBox stimulusData win=NT,disable=3
		ListBox scanLoadListbox, win=NT,disable=3
	Else
		//shift text label if there is a non-zero size
		SetDrawEnv/W=NTP  fstyle= 0
		DrawAction/W=NTP delete,getgroup=parameterText
		SetDrawEnv/W=NTP xcoord= abs,ycoord= abs, textrgb= (0,0,0), fsize=14, textxjust= 1,textyjust= 1,fname=$LIGHT,gstart,gname=parameterText
		DrawText/W=NTP 455+(size/2)-6,15,"Parameters"
		SetDrawEnv/W=NTP gstop	
	EndIf
	
	//hide the list selector menu unless the command is 'Run Cmd Line', in which case it is hidden
	strswitch(selectedCmd)
		case "Run Cmd Line":
		case "New Data Folder":
		case "Kill Data Folder":
		case "External Function":
		case "Load Ephys":
		case "Load WaveSurfer":
		case "Load pClamp":
		case "Load Scans":
		case "Load Suite2P":
		case "Population Vector Sum":
			Button WaveListSelector win=NT,disable=3
			break
		default:
			Button WaveListSelector win=NT,disable=0
			break
	endswitch
	
	//Erase the help message
//	switchHelpMessage("")
	
	
	Variable i = 0
	Do
	
		//Get original window coordinates
		GetWindow NT wsize
		Variable left,top,right,bottom
		left = V_left;right=V_right;top=V_top;bottom=V_bottom
		Variable expansion = (r * right - r * left) - 754 //current expansion relative to original width of the panel
		
		If(!i)
			Variable totalReduction = expansion
		EndIf
		
		If(expansion <= size)
			ControlInfo/W=NTP#navigatorPanel folderListBox
			Folders_Position = 460 + V_width + size
			break
		EndIf
		
		Variable pixelsLeft = expansion - size
		If(pixelsLeft < ppr)
			MoveWindow/W=NTP left,top,right-(pixelsLeft/r),bottom;DelayUpdate
			Variable shift = size
		Else
			//Extend right edge of the panel to make room
			MoveWindow/W=NTP left,top,right-delta,bottom;DelayUpdate
			shift = expansion - delta
		EndIf

		//Shift the right line
		SetDrawEnv/W=NTP  fstyle= 0
		DrawAction/W=NTP delete,getgroup=rightLine
		SetDrawEnv/W=NTP xcoord= abs,ycoord= rel,textxjust= 1,textyjust= 1,linefgc= (0,0,0,16384),linethick= 4,gname=rightLine,gstart
		DrawLine/W=NTP 448 + shift,0, 448 + shift,1;DelayUpdate
		SetDrawEnv/W=NTP gstop,textxjust= 1,textyjust= 1

		DoUpdate/W=NTP
		i += 1
	While(expansion > size )
	
	//delete midline after animation
	If(!size)
		DrawAction/W=NTP delete,getgroup=rightLine
	EndIf
	
	//expand group box first
	If(size > 13)
		GroupBox parameterBox win=NT,pos={455,69},size={size-13,437}
	EndIf
	
End

//Allows user to click on command line entries while using 'Run Cmd Line'
// and selectively delete and edit entries
Function cmdLineEntryHook(s)
	STRUCT WMWinHookStruct &s
	DFREF NPC = $CW
	NVAR foldStatus = NPC:foldStatus
	
	Variable hookResult = 0
	
	switch(s.eventCode)
		case 0:
			//handle activate
			break
		case 1: 
			//handle deactivate
			break
		case 3:
			//handle mouse down
			SVAR masterCmdLineStr = NPC:masterCmdLineStr

			If(s.eventMod == 16 || s.eventMod == 17) //right click
				Variable numEntries = ItemsInList(masterCmdLineStr,";/;")
				GetMouse/W=NTP
				
				Variable selection = whichCmdLineEntry(V_left,V_top,numEntries)
				
				//NaN, no valid selection
				If(numtype(selection) == 2)
					//Reset selection drawing
					DrawAction/W=NTP getgroup=cmdEntrySelection,delete
					return 0
				EndIf
				
				PopupContextualMenu/C=(V_left,V_top) "Edit;Delete;"
				
					
				String popStr = S_Selection
				Variable popNum = V_flag
				
				If(V_flag == 0 || V_flag == -1)
					break
				EndIf
				
				//If the selection was a break line in the menu
				If(cmpstr(popStr[0],"-") == 0)
					//Reset selection drawing
					DrawAction/W=NTP getgroup=cmdEntrySelection,delete
					return 0
				EndIf
				
				strswitch(popStr)
					case "Edit":
						EditCmdLineEntry(selection)
						break
					case "Delete":
						DeleteCmdLineEntry(selection)
						break
				endswitch
				
				//Reset selection drawing
				DrawAction/W=NTP getgroup=cmdEntrySelection,delete
	
				hookResult = 1
			EndIf
			
			break
	endswitch
	return hookResult
End

//Figures out which command line entry was clicked on
//Draws a selection indicator
Function whichCmdLineEntry(left,top,num)
	Variable left,top,num
	
	Variable yPos = 144
	
	//Reset selection drawing
	DrawAction/W=NTP getgroup=cmdEntrySelection,delete
	
	If(left > 455 && left < 624) 
		If(top > yPos && top < yPos + 20 && num > 0)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos,458,yPos+20
			SetDrawEnv gstop
			return 0
		ElseIf(top > yPos + 20 && top < yPos + 40 && num > 1)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+20,458,yPos+40
			SetDrawEnv gstop
			return 1
		ElseIf(top > yPos + 40 && top < yPos + 60 && num > 2)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+40,458,yPos+60
			SetDrawEnv gstop
			return 2
		ElseIf(top > yPos + 60 && top < yPos + 80 && num > 3)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+60,458,yPos+80
			SetDrawEnv gstop
			return 3
		ElseIf(top > yPos + 80 && top < yPos + 100 && num > 4)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+80,458,yPos+100
			SetDrawEnv gstop
			return 4
		ElseIf(top > yPos + 100 && top < yPos + 120 && num > 5)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+100,458,yPos+120
			SetDrawEnv gstop
			return 5
		ElseIf(top > yPos + 120 && top < yPos + 140 && num > 6)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+120,458,yPos+140
			SetDrawEnv gstop
			return 6
		ElseIf(top > yPos + 140 && top < yPos + 160 && num > 7)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+140,458,yPos+160
			SetDrawEnv gstop
			return 7
		ElseIf(top > yPos + 160 && top < yPos + 180 && num > 8)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+160,458,yPos+180
			SetDrawEnv gstop
			return 8
		ElseIf(top > yPos + 180 && top < yPos + 200 && num > 9)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+180,458,yPos+200
			SetDrawEnv gstop
			return 9
		ElseIf(top > yPos + 200 && top < yPos + 220 && num > 10)
			SetDrawEnv linefgc= (3,52428,1),linethick= 3.00,xcoord=abs,ycoord=abs,gname=cmdEntrySelection,gstart
			DrawLine/W=NTP 458,yPos+200,458,yPos+220
			SetDrawEnv gstop
			return 10
		EndIf
	EndIf
End

//Deletes a specific command from the master command line entry, redraws
Function DeleteCmdLineEntry(selection)
	Variable selection
	
	DFREF NPC = $CW
	SVAR masterCmdLineStr = NPC:masterCmdLineStr
	
	masterCmdLineStr = RemoveListItem(selection,masterCmdLineStr,";/;")
	DrawMasterCmdLineEntry()
End

Function EditCmdLineEntry(selection)
	Variable selection
	
	DFREF NPC = $CW
	SVAR masterCmdLineStr = NPC:masterCmdLineStr
	NVAR editingMasterCmdLineStr = NPC:editingMasterCmdLineStr
	
	//Pull the entry into the editing box
	SetVariable cmdLineStr win=NT,value=_STR:StringFromList(selection,masterCmdLineStr,";/;"),activate
	
	
	//Set editing details
	editingMasterCmdLineStr = selection
End


Function SendNotificationTask(s)		// This is the function that will be called periodically
	STRUCT WMBackgroundStruct &s
	DFREF NPC = $CW
	
	NVAR maxNotificationSize = NPC:maxNotificationSize
	SVAR notificationEntry = NPC:notificationEntry
	NVAR funcPanelWidth = NPC:funcPanelWidth
	NVAR screenBottom = NPC:screenBottom
	NVAR notificationSize = NPC:notificationSize
	notificationSize += 50
	
	If(notificationSize > 1000)
		//end the notification after some additional time
		StopNotificationTask()
		
	ElseIf(notificationSize < maxNotificationSize)
		//Animate the notification box
		GroupBox notificationBox win=NTP#Func,align=1,size={notificationSize,50}
	Else
		//after reaching a certain size (maxNotificationSize), the text pops up in the notification box
		DrawAction/W=NTP#Func getgroup=notificationText,delete
		SetDrawEnv/W=NTP#Func gname=notificationText,gstart
		SetDrawEnv/W=NTP#Func xcoord= abs,ycoord= abs, fsize=16, textxjust= 0,textyjust= 1,fname="Helvetica Light"
		DrawText/W=NTP#Func funcPanelWidth - maxNotificationSize + 50,screenBottom-35,notificationEntry
		SetDrawEnv/W=NTP#Func gstop
	EndIf
	
	return 0	// Continue background task
End

Function SendNotification([maxSize])
	Variable maxSize //max width of the notification box to accomodate longer text
//	
//	DFREF NPC = $CW
//	Variable/G NPC:maxNotificationSize
//	NVAR maxNotificationSize = NPC:maxNotificationSize
//	
//	maxNotificationSize = (ParamIsDefault(maxSize)) ? 300 : maxSize
//	
//	Variable/G NPC:notificationSize
//	NVAR notificationSize = NPC:notificationSize
//	notificationSize = 0
//	
//	NVAR funcPanelWidth = NPC:funcPanelWidth
//	NVAR screenBottom = NPC:screenBottom
//	
//	//Initialize the notification
//	GroupBox notificationBox win=NTP#Func,pos={funcPanelWidth - 10,screenBottom-60},align=1,size={notificationSize,50},disable=0,labelBack=(0,0xb000,0,0x4000)
//	
//	Variable numTicks = 1		
//	CtrlNamedBackground sendNotification, period=numTicks, proc=SendNotificationTask
//	CtrlNamedBackground sendNotification, start
	
//	DFREF NPC = $CW
//	
//	NVAR maxNotificationSize = NPC:maxNotificationSize
//	SVAR notificationEntry = NPC:notificationEntry
//	
//	Notebook NTP#Func#DSNotebook,selection={startOfFile,endOfFile},getData=1
//	Notebook NTP#Func#DSNotebook,selection={startOfFile,endOfFile},setData=notificationEntry
End

Function StopNotificationTask()
	CtrlNamedBackground sendNotification, stop
	DrawAction/W=NTP#Func getgroup=notificationText,delete
	KillControl/W=NTP#Func notificationBox
End


//SHORTCUTS-----------------------------------------------------------

//Function/S handleShortcut()
	DFREF NPC = $CW
	DFREF NPD = $DSF
	
	//Get the activated shortcut
	GetLastUserMenuInfo
	
	Wave/T shortCuts = NPC:shortCuts
	SVAR selectedCmd = NPC:selectedCmd
	SVAR prevCmd = NPC:prevCmd
	
	String theFunction = shortCuts[str2num(S_Value)-1][1]
	
	//Make sure we're in the function tab
	NVAR currentTab = NPC:currentTab
	
	//special case for Data Sets, need a tab switch, not a function switch
	If(!cmpstr(theFunction,"Data Sets"))
		TabControl tabMenu win=analysis_tools,value=0
		switchTabs(0)
		currentTab = 0
		return ""
	EndIf

	If(currentTab == 0)
		TabControl tabMenu win=analysis_tools,value=1
		switchTabs(1)
		currentTab = 1
	EndIf
	
	//kill previous text in the panel
	DrawAction/W=NPC delete
	
	prevCmd = selectedCmd
	selectedCmd = theFunction
	ChangeControls(selectedCmd,prevCmd)
	
	//Refresh external function page when it opens
	If(cmpstr(selectedCmd,"External Function") == 0)
		CheckExternalFunctionControls(selectedCmd)
	Else
		strswitch(selectedCmd)
			case "Apply Map Threshold":
			case "Denoise":
			case "Average":
			case "Mask Image":
			case "Dynamic ROI":
			case "Error":
			case "Move To Folder":
			case "Kill Waves":
			case "Run Cmd Line":
			case "Duplicate Rename":
				Wave/T DSNamesLB_ListWave = NPC:DSNamesLB_ListWave
				SVAR DSNames = NPD:DSNames
				DSNames = "--None--;--Scan List--;--Item List--;" + textWaveToStringList(DSNamesLB_ListWave,";")		
				break
		endswitch
	EndIf
	
	Button AT_CommandPop win=analysis_tools,title = "\\JL▼    " + selectedCmd
	DrawText/W=NTP 15,53,"Commands:"
	ControlInfo/W=NTP CommandMenu
						
	If(!cmpstr(selectedCmd,"External Function"))
		DrawText/W=NTP 23,84,"Functions:"
	EndIf

End

// PNG: width= 43, height= 43
Picture MagnifierPict
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!!L!!!!L#R18/!9%4'^]4?;ZY<B@FBD723b*)F/n&:/@V%0:D/]IT!!!
	!]5Bq-U@r#Xt+C\npBl6'Xn%6=Y+DG@L,$-Wr0MQLRAS>dKH?*RqH;7FLH>@"NA0O6%$9WPoG\qD:A
	TV?'G\q87F#nP/,%5##@V%T<F#n/LFC?gH+F#qlD/aT44X+!&:`r,DEb-@N/i>78,!H>V4E=tE3`8@
	8+F%a>DK@jZA7dtKBQS?83\N.1GBYZ`1G3TdB.ku"3B8`H1+tC</TPB6/TZ2TFCBDGDK@$H4piDT4E
	=tE3^dP#@rc:&FD5Z2+ED")3alK9F`]bj+poG8+<YoGCi4;TAU%p$4X+Q]FDs8o05bh`@:X:cAM.J2
	D(fIFBkB"Q/heq&$6UH6+F%a>DK@j\BkCs?,%u(?E&oX*DK@F=A8bpg/n8g:06Co?AhPkk0J=UW+<V
	dLG\q87F#n8RDffo=BQ%iQ,%u(?E&oX*DK@F=A8bpg/n8g:05tTCFDl56Df@?a/heq&$6UH6+F%a>D
	K@j`D/_W^BQS?83\N.(F"Um3Ddm91@rH3;G[YPE0eP.5+poG8+<YoGCi4;TG\qCo9g'\6FEDI_0/%3
	a/n&:/@V%0%Df%.P@;mkS/heqqD(d(?+<VdLG\q87F#nAa7<Wc9,%u(?E&oX*DK@F=A8bpg/n8g:06
	goE0/5(506:*<E+L\#ATMd4EarZLG%GQ5,9dI;+<Y6?BkBD&Bm=3*=@?k?ASuR'Df.]^1c$<_+<Ve<
	G\LbN:hb/cCfs/?D.RU+Bl@lP+uD)"$6UH6AU%p$3^[h%DfScq@:Nk3+u(8K+<VeKBkCs<8SqmKAQN
	SVFD*f]1c$<_+<VeKBkCs<8SqmKAP?ZQB67fM+uD)"$6UH6FD5?!3`9O1DesQ<Bl@lhDJ=2U+u1>L+
	<VeKBkCs<=Ai^ODesQ<Bl@lP+u_810d6rI+<Yc?AnF),;IsofCisi6Df.]^2_m$@+poG8+E2"4FDl5
	6Df@a)Des?49lFQR4X)[+$6UH6E+j03Df]T1E&pQX6VqfAAnc'm4X+rF7m\=i77/sf3ArcI1+k:*$6
	UH6G\qC\9lFQVApHdQFCdTZ1,(I=/MSq21,`)d2**EI3\iB@0K2$H0HpiH+<YoGE&p^)FCA]gFC@RG
	FCdTZ1,(I=/MSq21,`)d2**EI3\iB@0K2$H0Hr[f+<VdhG\qCo9fbgZF*)>@Gs2QX+<VdhEb&cC;e9
	r4$6UH6+<WdeA7dl=BaPt*+<VdLF*'ioF?3i?FD5Z24X+icDe+!#ARltl+<VdL+<Y`I7<Wc6F)PZ4G
	@>N'6"abHF?Lg6AnGapBlnVC6tLFRB5V:$+>GK'0J54,$6UH6+<VeJF@C@p3d57KDET1!0JYC80eb1
	72H2Cg3\W?N1,(:62``WH+tl+e+<VdL4>1_cAi`k%EBX^P+<Wd"G\qCo9fbgZF*)>@Gs2QX+?V;tA7
	dkjATM@%BlJ0.Df.`G+?V;tA7dl#6q0?I4>1q?G\qD:ATV?E$9UOtE+*6lATT&+DIbmSE[!_3/W%T>
	!!!%NBgY6aF&GLp+A#!h2DI3M2D$[:0`V2%O`cf4.n!5Ka$40l`b6&YZ?U(c%J`j7)eC@iUhPcCfZZ
	JLB%4J]f6\aa<nSrpD#@K+(U-oj8eELTb*ptUk<,M/1?WiKq:tGPkB-1'i/2)Gh5]fG4]a>4,9^VZ5
	,2(Aih;&QWph95b8?+)`[P\A2cMd,WmdqIrnP7h4.ifXW2L:L<"6/V4=WJ-<%o<K'Q-l+M0\&iiIE?
	n'Y\b_A<EK(:)E`D@5AZ.K<&<\8cRf2030m+/hAZrY@e[%TDLT$nYU>*P7lWg>Hru>63r9"L'\NhLB
	3fqFOEgKX=0:irLH/=??0&6%@/_O+AIRl!DsZ0H:jnYH:gYmAZ,QXqeBhn]uB9n&6(gFp.IJHDntPI
	D85Pop?)Idn)5g!b0TNBs/YAL--a14^/[-Q058N[3*h1!4!S/\^*U7u9@Mhp#jUErE!`,h@aBMs3P:
	'uML<qXD!sWESG19V!>`1X_%>b7rr<$!$#iF<ErZ1J'*&"?'*/*%S/;5+"*7%%5u^s?mFY'Fgf5'/n
	^""*PJ3nXW[.6LCo^)qMaYN6LnH/P.n+Xh0!&%!Ka::N<('+WE?g&SpPK>aL`d$WFO<NC;(U;-[;AN
	g`eGgS@cQJB+(gsR-NA?f/EXDZ1-+OSmlgF#F3bkm[4IRaO*:c1`F]P=:],fmfRn[b)8$ci_fue=R)
	e)DL+04@3`IhiEP*m]B,#LuT#3JaM!9Zooj]3nE4k0,5)K+M?GOnS9Xpfack3oh9R<@^fNJ7b?kT)A
	2(k3Y%q,ZtA76"i%X_W,dS;!5*F?[nR):9(mbO%uc*SNf94%W@.C3"iok'VKgPtPRhS@`smoB,scet
	uQHr&ZV=jVT9hZkkc41&OOgPP8(]J!-M_q!Cr5M?sLV?+=UO;#,.O'*Z^qq@Fq@6)R[A1O;;&<u8D/
	mKk,q[Uq*j]!"=&9hPV%aeU1dh-1t1O)L^Fr"k56S!qtYkLahqeuRBl(%8XmD46fORfleQ#TsZgMp=
	\hp^[]Zp:fe76)g/es*-BC^&uoWN"n#*WS*56ILD6hpH%jARMREC06="]0]_,`u7.FCh?WNG*DdF-R
	HXCeo,T`:#`Hj7V,sdW(2$BQ!kK_00;-<.CZ7u^lGDOFDJMO>#_7pD:WAt]?@u2P.R@%p32L>\i.^5
	\6b*mU($C10bCl:[rk?P5S\iLI-ti`=LQKrPY*Wi41[a??(9Bj`&rK`AloiB?!JR2nJ9fd?DrIBV1D
	dOFc0B@p']!mMO`JR46J[oO31+)<[.HF/*!q>o)cEj]mMuq+^e"hP#@'TNqCC_=uit=I/f4rU`PQTB
	%ac!3WRtgMr,l_gOdJr&+ZH0pK;R/Ur4X$gK[^:nH=l<n6_#bV/`]P%(8g<F^QZ]Fs:/08+O:-Ki0(
	S82L7,D!Q)?(l_g(7=*OsV88`V^fD2s]9Rb#QAo\q+(IeAGoIfeQYZ!Y=2juu)H.:E62B>E:>TYS$e
	li8`ckQ0:YUS/#^WON"Lq<Xi0]^uSmB:LENZ!E5p+0HraZE6[UEBk2NG$EpIh=Z,rOiGn-g"Sj2G+B
	9#K(UeJdh#BeD"kl*j8+K%Cf&lZs#K:n<30E@lh:>0ESPel`(^GKTURT*ML_*bPfCZMsUp(HqQ;TK.
	SMTE"rl!(fUS7'8jaJc
	ASCII85End
End


// PNG: width= 43, height= 43
Picture MagnifierOnPict
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!!L!!!!L#R18/!9%4'^]4?;ZY<B@FBD723b*)F/n&:/@V%0:D/]IT!!!
	!]5Bq-U@r#Xt+C\npBl6'Xn%6=Y+DG@L,$-Wr0MQLRAS>dKH?*RqH;7FLH>@"NA0O6%$9WPoG\qD:A
	TV?'G\q87F#nP/,%5##@V%T<F#n/LFC?gH+F#qlD/aT44X+!&:`r,DEb-@N/i>78,!H>V4E=tE3`8@
	8+F%a>DK@jZA7dtKBQS?83\N.1GBYZ`1G3TdB.ku"3B8`H1+tC</TPB6/TZ2TFCBDGDK@$H4piDT4E
	=tE3^dP#@rc:&FD5Z2+ED")3alK9F`]bj+poG8+<YoGCi4;TAU%p$4X+Q]FDs8o05bh`@:X:cAM.J2
	D(fIFBkB"Q/heq&$6UH6+F%a>DK@j\BkCs?,%u(?E&oX*DK@F=A8bpg/n8g:06Co?AhPkk0J=UW+<V
	dLG\q87F#n8RDffo=BQ%iQ,%u(?E&oX*DK@F=A8bpg/n8g:05tTCFDl56Df@?a/heq&$6UH6+F%a>D
	K@j`D/_W^BQS?83\N.(F"Um3Ddm91@rH3;G[YPE0eP.5+poG8+<YoGCi4;TG\qCo9g'\6FEDI_0/%3
	a/n&:/@V%0%Df%.P@;mkS/heqqD(d(?+<VdLG\q87F#nAa7<Wc9,%u(?E&oX*DK@F=A8bpg/n8g:06
	goE0/5(506:*<E+L\#ATMd4EarZLG%GQ5,9dI;+<Y6?BkBD&Bm=3*=@?k?ASuR'Df.]^1c$<_+<Ve<
	G\LbN:hb/cCfs/?D.RU+Bl@lP+uD)"$6UH6AU%p$3^[h%DfScq@:Nk3+u(8K+<VeKBkCs<8SqmKAQN
	SVFD*f]1c$<_+<VeKBkCs<8SqmKAP?ZQB67fM+uD)"$6UH6FD5?!3`9O1DesQ<Bl@lhDJ=2U+u1>L+
	<VeKBkCs<=Ai^ODesQ<Bl@lP+u_810d6rI+<Yc?AnF),;IsofCisi6Df.]^2_m$@+poG8+E2"4FDl5
	6Df@a)Des?49lFQR4X)[+$6UH6E+j03Df]T1E&pQX6VqfAAnc'm4X+rF7m\=i77/sf3ArcI1+k:*$6
	UH6G\qC\9lFQVApHdQFCdTZ1,(I=/MSq21,`)d2**EI3\WHD0K2$H0HpiH+<YoGE&p^)FCA]gFC@RG
	FCdTZ1,(I=/MSq21,`)d2**EI3\WHD0K2$H0Hr[f+<VdhG\qCo9fbgZF*)>@Gs2QX+<VdhEb&cC;e9
	r4$6UH6+<WdeA7dl=BaPt*+<VdLF*'ioF?3i?FD5Z24X+icDe+!#ARltl+<VdL+<Y`I7<Wc6F)PZ4G
	@>N'6"abHF?Lg6AnGapBlnVC6tLFRB5V:$+>GK'0J54,$6UH6+<VeJF@C@p3d57KDET1!0JYC80eb1
	72H2Cg3\W?N0K(L:2``WH+tl+e+<VdL4>1_cAi`k%EBX^P+<Wd"G\qCo9fbgZF*)>@Gs2QX+?V;tA7
	dkjATM@%BlJ0.Df.`G+?V;tA7dl#6q0?I4>1q?G\qD:ATV?E$9UOtE+*6lATT&+DIbmSE[!_3cuU%t
	!!!%NBgY6aF&GLp+A#!h2DI3M2D$[:0`V2%O`cf4.n!5Ka$40l`b6&YZ?U(c%J`j7)eC@iUhPcCfZZ
	JLB%4J]f6\aa<nSrpD#@K+(U-oj8eELTb*ptUk<,M/1?WiKq:tGPkB-1'i/2)Gh5]fG4]a>4,9^VZ5
	,2(Aih;&QWph95b8?+)`[P\A2cMd,WmdqIrnP7h4.ifXW2L:L<"6/V4=WJ-<%o<K'Q-l+M0\&iiIE?
	n'Y\b_A<EK(:)E`D@5AZ.K<&<\8cRf2030m+/hAZrY@e[%TDLT$nYU>*P7lWg>Hru>63r9"L'\NhLB
	3fqFOEgKX=0:irLH/=??0&6%@/_O+AIRl!DsZ0H:jnYH:gYmAZ,QXqeBhn]uB9n&6(gFp.IJHDntPI
	D85Pop?)Idn)5g!b0TNBs/YAL--a14^/[-Q058N[3*h1!4!S/\^*U7u9@Mhp#jUErE!`,h@aBMs3P:
	'uML<qXD!sWESG19V!>`1X_%>b7rr<$!$#iF<ErZ1J'*&"?'*/*%S/;5+"ij2&5u^s?m?hU('NH-gI
	rBLS[`>W>[b,b-TG8kAK*]9n"h]Fr+N=eFJiBS=N5hNI7Y8Qlckml;&5X&D0+nhP&[@r:[iFDDO`2(
	>Q7g2X41*gZ`XfDoA_V'7O2;]^T6=l(HiN!9H11di)n=.0&/fAh(GGjQ%X7sg3!C9&rW"/,1nG"V%k
	nA>#7TN?i!5\N),L;LO9JklQ=Gg0<7r7!2GaPs#Fa]@o`2Y?Kp_0=B!4,omfOr$$(.`/3Nrdf`U$18
	;^rh;.M6qIO6!8'0$-J9gTqA3e,tL*NJ+rN4m4u*2q=HRG(mi(!ZXID?lAHT8'9ZrbQSIX@@)ng6\a
	8!/m+:+='d$rXJGY$5+:6e?h\'7Y.i36"R&*Hi-/RK8'$",'u40AG0`cpm*%DZq3.[ejU-ntmGAQa]
	fs,$qtiWhF!O((:^O5?64YFgCBN,g`rNgQ5hhO2)jU?LZGaGELd1s;^8P`beqH"O,+Jl6!O'nr(euF
	+'[55MlrGa1>.uc4Q&6u?dg=44;3ZM3Cnma8LOhJQe[$/G$Q'=034%g)i?`,.<F:)fVGWjY=L^=p.I
	/0!#=:[.0W;*72N)E:K/m8-#7\,$=gh4J8SP/mPa:!=olYT3rk/o9Y&ar[&(m,F][`)S"6Y3WajZg6
	2QMmPJTp9fG:Mo.#%M8#c>>REOVNBc0M4I%kE'*^B4`tp>^:q\@OW]$[i$$MW2p_:(ZnXpfNAo1/'l
	$.O/(>PajH`0bf-;VX@+\[S,de+-/!#s9np:V8.NkQV^Y5aZ?\ibf&[P<bimkRT.6=h3Iq8B=ko.<S
	/']]U05Csdt=(9]9/Z=_?&QtOAjh*$7.077FmC-eYBrr"@EKb8t@c9ocWDXl85G#EW3BjgC/`9Hp6A
	5jA9%Wk8"m=GgGXuJD=CeSer\"$t+3mT*=R_/otRH0>VFlOM&l<'0<i36NnkjOUA+Dfb7t;X0QMlY!
	CeRX+UD0(Q8c9R_AR;N,)M?H&W^bqsOGA-g&:m.TU,i@r@[QOi.%l)3_G.)/s0OU?67'GD:;DNJ3qB
	J</l+2Za/OiGR2hWiQ6Fa#pA,ftK=k@*P]:@lg>s:?sJ0/9"2PZOb,!3Qg=Gd`iPb3k<_%"kWk*!sP
	#k[X\-^F2R:.W<rTG+<5\#8PM?s<*p0gn*DZ,03FCtO"&NB:e5am._m#:21V"]B'@V#pAU\6V;rA7D
	SN/i(d=>Ck[43md!Oo^nIo:E'oRi^[OQTa8p_\Xk^/1`\#1J:!e(<Q0mE9)!LJ>LhGr"Qj2T9bUSDC
	sWilk7rkFV)^rbUt419j3^A];fpiBf<-5bYX+I@>kr@>Y/eV?BIBSq_U:_E!4<+TQ.cN5>ABg<KY@u
	^SS\anra>V)-TPmFq!=H]jo0uDeRHK`#f\8^;;*!;3&]%p+acX,$_)`B3MFI^ABXWl7J;j!%UI4uQR
	?jJGZP0e?B>+ut-":-/!/aXa.:Rp^Wc[$t^DmP9g3H0m#e9UR#gY8+&,mpja(g#*j)I\hs)@.6mR\*
	D1?tdg01ccVtZ;W/3\R\c@86OumbIm>%;p3GuH96*S>CG3^6sH<%DNCY4YBoO-OnEk.US(G:]2_D<r
	-TsH27cg#lH<4>P89.AmL;k14CY5*2+=I)`F!FU2D*>BBSK^k6STrtf4=1LUD0EAIQqVQ-tG^[5S:"
	.c'8rnKtudqRqT&\`6)[c1_rNYiFpMa%Tif9g8T+`KX)UB)N,fh7Ra7+JEML.R(9aZ>*\Jod9%*V?;
	Q=O#r!7Ldmh_cAZLBug]Z#,'VV*pK_dUr(?W[$GZl(,-"%*7NghF8M^$Za^f4\_E'EDbMhRi,^&k*j
	B"4DI=C;2L;A&3<>HH=<Rc2QD%/5EZm?&1a!FW\*Z&K!>9`P.n!(fUS7'8jaJc
	ASCII85End
End
//
//// PNG: width= 120, height= 20
//Picture PencilPict
//	ASCII85Begin
//	M,6r;%14!\!!!!.8Ou6I!!!"D!!!!5#R18/!(Kl^o)Jaok@mmtFBD723b*)F/n&:/@V%0:D/]IT!!!
//	!]5Bq-U@r#Xt+C\npBl6'Xn%6=Y+DG@L,$-Wr0MQLRAS>dKH?*RqH;7FLH>@"NA0O6%$9WPoG\qD:A
//	TV?'G\q87F#nP/,%5##@V%T<F#n/LFC?gH+F#qlD/aT44X+!&:`r,DEb-@N/i>78,!H>V4E=tE3`8@
//	8+F%a>DK@jZA7dtKBQS?83\N.1GBYZ`1G3TdB.ku"3B8`H1+tC</TPB6/TZ2TFCBDGDK@$H4piDT4E
//	=tE3^dP#@rc:&FD5Z2+ED")3alK9F`]bj+poG8+<YoGCi4;TAU%p$4X+Q]FDs8o05bh`@:X:cAM.J2
//	D(fIFBkB"Q/heq&$6UH6+F%a>DK@jXBQ&!2F(fK24X+Q]FDs8o05bh`@:X:cAM.J2D(fjADffo=BQ%
//	iC0eP.5+poG8+<YoGCi4;TFD5?!4X+Q]FDs8o05bh`@:X:cAM.J2D(g!FAnE\N/heq&$6UH6+F%a>D
//	K@j`D/_W^BQS?83\N.(F"Um3Ddm91@rH3;G[YPE0eP.5+poG8+<YoGCi4;TG\qCo9g'\6FEDI_0/%3
//	a/n&:/@V%0%Df%.P@;mkS/heqqD(d(?+<VdLG\q87F#nAa7<Wc9,%u(?E&oX*DK@F=A8bpg/n8g:06
//	goE0/5(506:*<E+L\#ATMd4EarZLG%GQ5,9dI;+<VeOD/=*23b2_`,%u(?E&oX*E-62;/oPcC04\QG
//	ASbppASuU20/5(60-U`G+<Y6?BkBCnDes?4;fH/TAN_4l+poG8+D#e3Ai`b&G\(\n6tpLLDKBN1DET
//	0u1,'mZ+<Ve<G\LbN:hb/cCfs/?D.RU+Bl@lP+u1hr$6UH6E+j03Df]T1E&p@)Ci=>gDe*EB+u:DM+
//	<VeGBQ&!2F(fK23_;\+:i^JdBl%?D,'-XP66Jig6T-YZ2E!-B/hnOW+<VeKBkCs<8SqmKAP?ZQB67f
//	M+u1hr$6UH6FD5?!3_=0sB4Y.YA9;KJ+u(i,+poG8+EV=0Ai`h$F)Pl;FD5Z2<GlMm4X)X*$6UH6FD
//	5?!3`o9kF)Pl;FD5Z24X)g?0/4XX+<VeKBkCs<=]/gPDesQ<Bl@lP+u_810d6rI+<YoGE&p^)FCA]g
//	FC@RGFCdTZ1,(I=/MSt30Jl``0KM$G3\W9?0K2$H0HpiH+<YoGE&p^3A8,Y$6t(1K4X)X81,:F90eG
//	(9<&$'f1bq*G0eG(<3\W634piDT+?XmcE(s%f883-eDfU+e$6UH6+?X[TAi`k%EBX^P+<VdL4E=tE3
//	c&L;+<VdL+<YoGE(s%f@:OCnDf.]^E,ol-F^nun+poG8+<VdLG\qCo9fd?6Aor6*Eb.OLASuTQ,!fg
//	QBl7X,Gp#LdF(o9)ATAnJ/ho%42'NAM+<VdL+F%aB9hdZmBOu'E+u1i-1+b47/M]4`0f;!G1HI9F/M
//	K+E0JF\(4piDT+<VdhEb&cCChX5!+<VdL+EMWnG'#cR@ruF'DET1_Ec5K2@qB0p$6UH6+<VeJF@C@p
//	3cf4OFE_/6AO0s?DKJ#c6"X_CDJ=3<+@Kd^BkM<pEZd(h0eb4;+poG8+<VdLF*'ioF?4VZASsXT1,(
//	I=/MSt30Jl``0KM$G3\W9?0K2$H0Hr/6$6UH6+?V;tA7dl$AT9m@+<Vdh06h>Q9hdZ>BleB7Ed9hU+
//	<VdhA7IZBBln0&4piDT+<WdeA7dkgCihiJ+<VdL+?X[TAiaaB+F%a>3c&5BB0@G`/S&F)@<HC.,!J_
//	0B5VEqBk;<]Bk)6I061T83c&Lo$6UH6+?V;tA7dkgCihiJ+<Vdh04\QRFD5i5ANgGD+?V;tA7dkjAT
//	M@%BlJ0.Df.`G+?V;tA7dl#6q0?I4>1q?G\qD:ATV?E$9UOtE+*6lATT&+DIbmSE[!_3I'++X!!!%M
//	BgY6aF&GLp+A#!h2DI3M2D$[:0`V2%O`cf4.n!5Ka$0cj)'Kb2e0M-BTI)S>9L;J%)!0@]k0:OV2*Y
//	F9]h+EiZCR`.`ifPq!F'-;'TnQTXGIC4cL]OVk1n6FTDQ=rSF/NV>`lCV0rfV_adRO#4Q)d"?guW/i
//	hhS[4L@Tn6Q;Sf%T1g6DQ'f"<Nf]/r4.=%*D[LZ<7D89.%5#\:C)_V9[2]oi>*^SN=-g9pZQW`iG2Y
//	Y3W*E/dbt_+ogh%JY!ui<ne]>qZ'*Nk_X__.1[2RCF!(9*Sj[aF7Uh-t)[9`j$/fBX0nT2bB38b1]a
//	W78/'?rM^@S8D8Zj8D7KK&kP,'er&N)5l',"<m'/IuMm/I%PX.^"537U.mW.(tPQS,5iJBss$^$f1V
//	k5eQ=_caF4TA,!l=4)pPX`G9sf&5W%UrBe#F<+QR[&>&EQ7BjZWX@'B:d5K8QVb0To^$4__cqqub#_
//	lap'u2fq1b_!(i*d$rX,:X!!!!*E(F,Q!!!B?!!!B?!<ARY(]XO@a@Scc<+pirRU8`e>8G3pW+i<+/
//	Juu7#9=ON:dB`-`aj1/ikU0_,<A3[R&FC$$*bdC":%eoMoNOGR+tk$R[RJj/g1^n=MQ+!7\bduT9[u
//	n,GdXq4%0Xu$abSYD]Y]LJJPe8No/mMC[_2,^V0>4f%NFNUS!&8=WS:m<@!pSA&VnsUf8gL)]Th;6i
//	r8+36pc1p:9!soAJP7S'bpI0g.[J`*[=L7>39J1@dbFBP<>q,ha4N'!aPH-n&2*50p-&T=fP'D/F,k
//	ZEgdkraP?O\[+CR1@h/5-JL!cMkd(Gl0<2oJ%]1&f%/CoZa-lA1BJX]H?@5;Z+PY'1)LG0E8^j*$4<
//	HVC8[#1*!_4,>')g]T;V;2f@QpBGB^e;Ra5M"Tr=mq"U,'CBP<dLB/5l]eCN4MEB7Go6c38XH?oudo
//	BGpo'G_IYTV)9GSSeY(fkc-5nDV:RVSMG<\g3SQLP:K3C:-T'8:Y$M#6:^QC,@h,cA6O$*!9BHG1X4
//	cX0&MCNZC2h0GqTF*6QFHnD_EF)0'i3h>Z?KKC(kEn\*E9r)IFElKW-&a2d6-gU@05o($fX2)Y3kdq
//	Z9PLknTsd4AcEVF>/XX]C?qf</OmA-C#ra^>qi*67%9q=B'qNCMr,PtJGPUX:XYlKT"PYI:kTjlPTC
//	3h8f::57;6"ikU2/1gE4hq?]9TMha)<E)r=^;\>p?!RoI>)hM"@3d-FTr4dn*fjql^;h^gC=/cg]Y)
//	#"`lA!0-qLjT786Jc]mKL6'FG!q=gE]Y;cDr!M%^R9&jd4fKXPgV5%@>i=BL7"jVeO<&-"7?2YIA!q
//	<I81aD<bu;Q1q(844mU.<PL_E=*'],I(?EgU:sg0k^=QjaS*f*OW(QYp)1T-K^+lE("g:hEA1!m?F$
//	,8Ks:Q%N[`'a,V18A]pB:=BHEZ`5MH4)]9N=:BlI1(ElSG2fkmTAQ^9*-=ULr,iIJ0Y@%=Y?nbOdal
//	gq(l#Ja'84Z:ekic]q\K)\2f8W8[^P(\>B'scom<0a%-Gnkbc,TM,@^0#T-.L'.c!4Vdh/4\l.\`rC
//	.U'E*Bu'NWM'OQ13*7LAT5WlgC4(E!MMmClWiCq%'$75&M\e$Q.28Cmk5&h/ClBuR^.d)-eKbcaB&t
//	8<ebU@2:0sU;Fh(aR.[@5AX^>A/]=ZhIgY;Tk#eiQllZTn6<%;=]=MD?N__B+0rdKV&GQBUEFEA3(K
//	`X0%mAk#EGB`?V0piJm!Pi0LR/?aVm!SEp@4hO6%.i%^ZOQD_a,@J.@'Nhjn89pek"Z!KDD5G[!l>e
//	uQaqVH#4lQs,Ts8po4]hm^VP;d$h.tOAS!0kk"Z!KB(4WgGBl%^i7HnEM@*\7"[3mL>9-eI<g1X9Re
//	"_jG#M^R*p)PH;FEpkDdLm#\kk9b<*!$h<i^Acp[Rcn3d^QOSN1bGeurFFc_^Hr]5clNN;X\7)l*?/
//	HocK>*3EP\H<tR,*fn@U:dCf'8EoC'[!VOb3dpi]&M;dC+sN)go3l*;_Qcp$K>Bg@R@+a0*DO)T\O=
//	Ao\\rKXI=-G?^C0.=Df7"W6:"hbDP`kn*$SRr\O8h!',)Gh(-5W&>*,&9#.\!!P`ulpGn[[u;-I.\N
//	upT8\S<lU1Zs0<qeEF`ES')M>?`&,*^,CG.p!oH/Ic<u3T)qE,paBJ*!?8s]Qk1Dg"Gu2QDa9/#ZU#
//	4q=5gA+$L+D>`M1,%Xk;uqpUf\="lc7\^Z)oeh&9aMKrRP^?XqGpaMSA=TeTW1:M2ZVO]em;L<aPmG
//	#+2P*2!,Vl.T(8U:=53D$&FHM6\C0apE#b>NM,p:N2JLkt(N@TiDae*/^c)o$k#3lT(WdF5!h.5!65
//	p@$m72Oht[>0Y=:,aD!$WMt_j2B2>_p6&=QS9O+Aq$%'/4,8QF%0"7()@c)i]9h7+gM,9B?'LS<7/d
//	)_Ib/o=l4o/p@VT^q,cfHfG.X=9o((q6\NYE;3B%o"bKI/9o4IXfomQYUE?(Q4GlkN]Nf8o*BXQPs9
//	4u".7\fM2.[=bj>`8DZY?o26/R.`'_uK$H*64bXYn8aZ$n"iB`;TT-B.])Ma]DA<K';E3]RTs1$=@(
//	E*C<+\EU)%&eCE+>[XSL6iNZ"O>!tc"Do\-/Q=A[]F_GZ1L<3smC2,6Xj5]+gG^+f1b2I:JeC<"7oU
//	\OC:A;HNl($9ANoP*CdNr_`ZjD&l*YsY;7ueQTI!e%'-74!!)]0Fekf[%7?[lH9I)X(DfW\cd>$G3>
//	1`CAl^]EfTZNhJjn]Eee?0KgD)u^b8#&Dhn779NHEcQ2F4)r(!:$Cm-o%WY`r:odm<i\+IO).]DPmZ
//	L/iE3L&'pM<:`l?#Cir]:9@9Re7?1N*OL5(Gtbba:%<i`K;bo/u<6m+]Y+)\QW2`@:_s.?r/;gNDH:
//	NeAe4PBQ/2gfYo`Nj;a92!GmZEgc*rP_f<<j()bET9KU9GSk880VV#g$aT1,>Rf<BP>KLEk0CFbI2P
//	:G$`>4aS=:mm'J-%S#'$IRW#E[StVjO5.B9`@Tg-^qNIKM!Ii`)pLsBe$ig8-!(fUS7'8jaJc
//	ASCII85End
//End
