﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Function RunInstaller()
	//Installation routine
	
	NewPanel/W=(400,400,760,500)/N=InstallProgress as "NeuroTools Installation"
	ValDisplay progressBar win=InstallProgress,pos={20,45},size={290,10},barmisc={0,0},limits={0,100,0},mode=3,highColor= (0,43690,65535),lowColor= (0,43690,65535),frame=5,value=_NUM:0
	
	DisplayInstallText("Acquiring Folder Paths...")
	Sleep/Q/S 0.5

	String AppUserFiles = SpecialDirPath("Igor Application",0,0,0)
	
	//Find the Igor Pro User Procedures folder
	String IgorUserFiles = SpecialDirPath("Igor Pro User Files",0,0,0)
	String UserProcedures = IgorUserFiles + "User Procedures"
	
	//Find the Igor Procedures folder
	String IgorProcedures = IgorUserFiles + "Igor Procedures"
	
	//Find the Igor Extensions 64 folder
	String IgorExtensions64 = IgorUserFiles + "Igor Extensions (64-bit)"
	String IgorExtensions = IgorUserFiles + "Igor Extensions"
	
	//Find the Igor Help Files folder
	String IgorHelp = IgorUserFiles + "Igor Help Files"
	
	//Find the folder with the NeuroTools package in it	
	PathInfo home
	String NTPath = S_path
	
	ValDisplay progressBar win=InstallProgress,value=_NUM:25
	DisplayInstallText("Installing JSON XOP...")
	Sleep/Q/S 0.5
	
	//JSON XOP
	strswitch(IgorInfo(2))
		case "Macintosh":
			String JSONXOP = NTPath + "JSON:output:mac:JSON-64.xop" 
			
			//Have to treat the XOP as a folder for some reason on Mac
			GetFileFolderInfo/Q/Z JSONXOP
			If(V_isFolder)
				CopyFolder/O/D/Z JSONXOP as IgorExtensions64
			Else
				CopyFile/O/D/Z JSONXOP as IgorExtensions64
			EndIf
			
			break
		case "Windows":
			String info = IgorInfo(0)
			String kind = StringByKey("IGORKIND",info,":",";")
			
			strswitch(kind)
				case "pro64":
				case "pro64 demo":
					JSONXOP = NTPath + "JSON:output:win:x64:JSON-64.xop" 
					CopyFile/O/D/Z JSONXOP as IgorExtensions64
					break
				case "pro":
				case "pro demo":
					JSONXOP = NTPath + "JSON:output:win:x86:JSON.xop" 
					CopyFile/O/D/Z JSONXOP as IgorExtensions
					break
			endswitch
			break
	endswitch	
	
	//JSON Help file
	String JSON_Help = NTPath + "JSON:docu:Json Help.ihf"
	CopyFile/O/D/Z JSON_Help as IgorHelp
	
	//JSON functions ipf
	String JSON_Functions = NTPath + "JSON:procedures:json_functions.ipf"
	CopyFile/O/D/Z JSON_Functions as IgorProcedures
	
	ValDisplay progressBar win=InstallProgress,value=_NUM:50
	DisplayInstallText("Installing NeuroTools procedure files...")
	Sleep/Q/S 0.5	
	
	//NeuroTools Loader file
	String NTLoader = NTPath + "NeuroToolsPlus_Loader.ipf"
	CopyFile/O/D/Z NTLoader as IgorProcedures
	
	//Create NeuroTools folder to hold the ipf files
	String NTFolder = UserProcedures + ":NeuroTools+:"
	NewPath/O/Q/Z/C NTFolderPath,NTFolder
	
	//Find the User/Library/Fonts folder for macs
	String SystemFontFolder = ParseFilePath(1,SpecialDirPath("Desktop", 0, 0, 0 ),":",1,0)
	SystemFontFolder += "Library:Fonts"
	
	//Create user functions folder
	String FunctionsFolder = UserProcedures + ":NeuroTools+:Functions:"
	NewPath/O/Q/Z/C NTFunctionsPath,FunctionsFolder
	
	//NeuroTools Help file
	String NT_Help = NTPath + "NeuroTools_Help.ihf"
	CopyFile/O/D/Z NT_Help as IgorHelp
	
	//Move all other ipfs into the NeuroTools home folder
	String fileList = "NeuroToolsPlus.ipf;NTP_ABF_Loader.ipf;NTP_Common.ipf;NTP_Controls.ipf;NTP_DataSets.ipf;NTP_Functions.ipf;NTP_Structures.ipf;NTP_DataLoader.ipf;PencilPict.png"
	Variable i,progressDelta = round(25 / ItemsInList(fileList,";"))
	
	Variable currentProgress = 50
	
	For(i=0;i<ItemsInList(fileList,";");i+=1)
		String theFile = StringFromList(i,fileList,";")
		String filePath = NTPath + theFile
		
		CopyFile/O/D/Z filePath as NTFolder
		
		If(!V_flag)
			currentProgress += progressDelta
			ValDisplay progressBar win=InstallProgress,value=_NUM:currentProgress
			DisplayInstallText("Installing NeuroTools procedure files..." + theFile)
			Sleep/Q/S 0.25	
		EndIf
	EndFor
	
	//Install special fonts for mac
	If(!cmpstr(IgorInfo(2),"Macintosh"))
		String NTFonts = NTPath + "Fonts:"
		NewPath/O/Q/Z FontPath,NTFonts
		String myFontList = IndexedFile(FontPath,-1,"????")
		For(i=0;i<ItemsInList(myFontList,";");i+=1)
			String theFontPath = NTFonts + StringFromList(i,myFontList,";")
			CopyFile/O/D/Z theFontPath as SystemFontFolder
		EndFor
	EndIf
		
	ValDisplay progressBar win=InstallProgress,value=_NUM:75
	DisplayInstallText("Installing HDF5 package...")
	Sleep/Q/S 0.5
	
	//Move the HDF5 package into place for Igor versions less than 9
	If(IgorVersion() < 9)
		String HDF5_XOP = AppUserFiles + "More Extensions (64-bit):File Loaders:HDF5-64.xop"
		String HDF5_Browser = AppUserFiles + "WaveMetrics Procedures:File Input Output:HDF5 Browser.ipf"
		
		//MacOS treats the XOP as a folder for some reason
		GetFileFolderInfo/Q/Z HDF5_XOP
		If(V_isFolder)
			CopyFolder/O/D/Z HDF5_XOP as IgorExtensions64
		Else
			CopyFile/O/D/Z HDF5_XOP as IgorExtensions64
		EndIf
		
		CopyFile/O/D/Z HDF5_Browser as IgorProcedures
	EndIf
	
	ValDisplay progressBar win=InstallProgress,value=_NUM:100
	DisplayInstallText("Installation Complete.")
	Sleep/Q/S 0.5
	
	KillWindow/Z InstallProgress
	
	DoAlert 0,"Installation Complete!\n\nRestart Igor.\n\nOpen NeuroTools from the 'NeuroTools' menu bar."

End

Function DisplayInstallText(installText)
	String installText
	
	DrawAction/W=InstallProgress getgroup=ProgressText,delete
	SetDrawEnv/W=InstallProgress fsize=12,xcoord=rel,ycoord=rel,textxjust=1,textyjust=1,gname=ProgressText,gstart
	DrawText/W=InstallProgress 0.5,0.75,installText
	SetDrawEnv/W=InstallProgress gstop
	DoUpdate/W=InstallProgress

End